// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S166_ReferencesPrimaryLegislation.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;

import java.util.ArrayList;


@SuppressWarnings("fallthrough")
class S166_ReferencesPrimaryLegislation extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int referenceState = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\1\2\0\2\1"+
    "\1\0\1\5\12\6\1\7\1\10\5\0\1\11\1\12"+
    "\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22"+
    "\1\23\1\24\1\25\1\26\1\27\1\30\1\22\1\31"+
    "\1\32\1\33\1\34\1\35\1\36\1\22\1\37\1\22"+
    "\1\40\1\0\1\41\1\0\1\42\1\0\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\0"+
    "\1\54\1\55\1\56\1\57\1\60\1\61\1\0\1\62"+
    "\1\63\1\64\1\65\1\66\1\67\1\0\1\70\266\0"+
    "\2\53\115\0\1\63\u0182\0\1\1\20\0\2\1\u0115\0"+
    "\1\54\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\2\1\2\2\2\3\12\0\1\4\106\0\1\5"+
    "\163\0\1\5\62\0\1\5\32\0\1\5\34\0\2\5"+
    "\34\0\1\5\24\0\1\5\12\0\1\6\1\7\1\5"+
    "\3\0\1\5\36\0\1\10\61\0\1\5\u0170\0\1\11"+
    "\11\0\1\12\17\0\1\12\33\0\1\12\277\0\1\12"+
    "\15\0\1\12\1\0\1\12\2\0\1\12\71\0\1\12"+
    "\2\0\1\12\222\0\1\12\27\0\1\12\22\0\1\12"+
    "\63\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[1399];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\71\0\162\0\253\0\344\0\253\0\u011d\0\253"+
    "\0\u0156\0\u018f\0\u01c8\0\u0201\0\u023a\0\u0273\0\u02ac\0\u02e5"+
    "\0\u031e\0\u0357\0\u0390\0\253\0\u03c9\0\u0402\0\u043b\0\u0474"+
    "\0\u04ad\0\u04e6\0\u051f\0\u0558\0\u0591\0\u05ca\0\u0603\0\u063c"+
    "\0\u0675\0\u06ae\0\u06e7\0\u0720\0\u0759\0\u0792\0\u07cb\0\u0804"+
    "\0\u083d\0\u0876\0\u08af\0\u08e8\0\u0921\0\u095a\0\u0993\0\u09cc"+
    "\0\u0a05\0\u0a3e\0\u0a77\0\u0ab0\0\u0ae9\0\u0b22\0\u0b5b\0\u0b94"+
    "\0\u0bcd\0\u0c06\0\u0c3f\0\u0c78\0\u0cb1\0\u0cea\0\u0d23\0\u0d5c"+
    "\0\u0d95\0\u0dce\0\u0e07\0\u0e40\0\u0e79\0\u0eb2\0\u0eeb\0\u0f24"+
    "\0\u0f5d\0\u0f96\0\u0fcf\0\u1008\0\u1041\0\u107a\0\u10b3\0\u10ec"+
    "\0\u1125\0\u115e\0\u1197\0\u11d0\0\u1209\0\u1242\0\u127b\0\u12b4"+
    "\0\u12ed\0\u1326\0\253\0\u135f\0\u1398\0\u13d1\0\u140a\0\u1443"+
    "\0\u147c\0\u14b5\0\u14ee\0\u1527\0\u1560\0\u1599\0\u15d2\0\u160b"+
    "\0\u1644\0\u167d\0\u16b6\0\u16ef\0\u1728\0\u1761\0\u179a\0\u17d3"+
    "\0\u180c\0\u1845\0\u187e\0\u18b7\0\u18f0\0\u1929\0\u1962\0\u199b"+
    "\0\u19d4\0\u1a0d\0\u1a46\0\u1a7f\0\u1ab8\0\u1af1\0\u1b2a\0\u1b63"+
    "\0\u1b9c\0\u1bd5\0\u1c0e\0\u1c47\0\u1c80\0\u1cb9\0\u1cf2\0\u1d2b"+
    "\0\u1d64\0\u1d9d\0\u1dd6\0\u1e0f\0\u1e48\0\u1e81\0\u1eba\0\u1ef3"+
    "\0\u1f2c\0\u1f65\0\u1f9e\0\u1fd7\0\u2010\0\u2049\0\u2082\0\u20bb"+
    "\0\u20f4\0\u212d\0\u2166\0\u219f\0\u21d8\0\u2211\0\u224a\0\u2283"+
    "\0\u22bc\0\u22f5\0\u232e\0\u2367\0\u23a0\0\u23d9\0\u2412\0\u244b"+
    "\0\u2484\0\u24bd\0\u24f6\0\u252f\0\u2568\0\u25a1\0\u25da\0\u2613"+
    "\0\u264c\0\u2685\0\u26be\0\u26f7\0\u2730\0\u2769\0\u27a2\0\u27db"+
    "\0\u2814\0\u284d\0\u2886\0\u28bf\0\u28f8\0\u2931\0\u296a\0\u29a3"+
    "\0\u29dc\0\u2a15\0\u2a4e\0\u2a87\0\u2ac0\0\u2af9\0\u2b32\0\u2b6b"+
    "\0\u2ba4\0\u2bdd\0\u2c16\0\u2c4f\0\u2c88\0\u2cc1\0\u2cfa\0\u2d33"+
    "\0\u2d6c\0\u2da5\0\u2cfa\0\u2dde\0\u2e17\0\u2e50\0\u2e89\0\u2ec2"+
    "\0\u2efb\0\u2f34\0\u2f6d\0\u2fa6\0\u2fdf\0\u3018\0\u3051\0\u308a"+
    "\0\u30c3\0\u30fc\0\u3135\0\u316e\0\u31a7\0\u31e0\0\u3219\0\u3252"+
    "\0\u328b\0\u32c4\0\u32fd\0\u3336\0\u336f\0\u33a8\0\u33e1\0\u341a"+
    "\0\u3453\0\u348c\0\u34c5\0\u34fe\0\u3537\0\u3570\0\u35a9\0\u35e2"+
    "\0\u361b\0\u3654\0\u368d\0\u36c6\0\u36ff\0\u3738\0\u3771\0\u37aa"+
    "\0\u37e3\0\u381c\0\u381c\0\u3855\0\u388e\0\u38c7\0\u3900\0\u3939"+
    "\0\u3972\0\u39ab\0\u39e4\0\u3a1d\0\u3a56\0\u3a8f\0\u3ac8\0\u3b01"+
    "\0\u3b3a\0\u3b73\0\u3bac\0\u3be5\0\u3c1e\0\u3c57\0\u3c90\0\u3cc9"+
    "\0\u3d02\0\u3d3b\0\u3d74\0\u3dad\0\u3de6\0\u3e1f\0\u3e58\0\u3e91"+
    "\0\u3eca\0\u3f03\0\u3de6\0\u3f3c\0\u3f75\0\u3fae\0\u3fe7\0\u4020"+
    "\0\u4059\0\u4092\0\u40cb\0\u4104\0\u413d\0\u4176\0\u41af\0\u41e8"+
    "\0\u4221\0\u425a\0\u4293\0\u42cc\0\u4305\0\u433e\0\u4377\0\u43b0"+
    "\0\u43e9\0\u4422\0\u445b\0\u4494\0\u44cd\0\u4506\0\u4422\0\u445b"+
    "\0\u453f\0\u4578\0\u45b1\0\u45ea\0\u4623\0\u465c\0\u4695\0\u46ce"+
    "\0\u4707\0\u4740\0\u4779\0\u47b2\0\u47eb\0\u4824\0\u485d\0\u4896"+
    "\0\u48cf\0\u4908\0\u4941\0\u497a\0\u49b3\0\u49ec\0\u4a25\0\u4a5e"+
    "\0\u4a97\0\u4a5e\0\u4ad0\0\u4b09\0\u4b42\0\u4b7b\0\u4bb4\0\u4bed"+
    "\0\u4c26\0\u4c5f\0\u4c98\0\u4cd1\0\u4d0a\0\u4d43\0\u4d7c\0\u4db5"+
    "\0\u4dee\0\u4e27\0\u4e60\0\u4e99\0\u4ed2\0\u4f0b\0\u4f44\0\u4f7d"+
    "\0\u4fb6\0\u4ed2\0\u4fef\0\u5028\0\u5061\0\u509a\0\u50d3\0\253"+
    "\0\253\0\u510c\0\u5145\0\u517e\0\u51b7\0\u51f0\0\u5229\0\u510c"+
    "\0\u5262\0\u529b\0\u52d4\0\u51f0\0\u530d\0\u5346\0\u537f\0\u53b8"+
    "\0\u53f1\0\u542a\0\u5463\0\u549c\0\u54d5\0\u550e\0\u5547\0\u5580"+
    "\0\u55b9\0\u55f2\0\u562b\0\u5664\0\u569d\0\u56d6\0\u570f\0\u5748"+
    "\0\u5781\0\u57ba\0\u57f3\0\u582c\0\253\0\u5865\0\u589e\0\u58d7"+
    "\0\u5910\0\u5949\0\u5982\0\u59bb\0\u59f4\0\u5a2d\0\u5a66\0\u5a9f"+
    "\0\u5ad8\0\u5b11\0\u5b4a\0\u5b83\0\u5bbc\0\u5bf5\0\u5c2e\0\u5c67"+
    "\0\u5ca0\0\u5cd9\0\u5d12\0\u5d4b\0\u5d84\0\u5dbd\0\u5df6\0\u5e2f"+
    "\0\u5e68\0\u5ea1\0\u5eda\0\u5f13\0\u5f4c\0\u5f85\0\u5fbe\0\u5ff7"+
    "\0\u6030\0\u6069\0\u60a2\0\u60db\0\u6114\0\u614d\0\u6186\0\u61bf"+
    "\0\u61f8\0\u6231\0\u626a\0\u62a3\0\u62dc\0\u6315\0\u634e\0\u6387"+
    "\0\u63c0\0\u63f9\0\u634e\0\u6432\0\u646b\0\u64a4\0\u64dd\0\u6516"+
    "\0\u654f\0\u6588\0\u65c1\0\u65fa\0\u6633\0\u666c\0\u66a5\0\u66de"+
    "\0\u6717\0\u6750\0\u6789\0\u67c2\0\u67fb\0\u6834\0\u686d\0\u68a6"+
    "\0\u68df\0\u6918\0\u6951\0\u698a\0\u69c3\0\u69fc\0\u6a35\0\u6a6e"+
    "\0\u6aa7\0\u6ae0\0\u6b19\0\u6b52\0\u6b8b\0\u6bc4\0\u6bfd\0\u6c36"+
    "\0\u6c6f\0\u6ca8\0\u6ce1\0\u6d1a\0\u6d53\0\u6d8c\0\u6dc5\0\u6dfe"+
    "\0\u6e37\0\u6e70\0\u6ea9\0\u6ee2\0\u6f1b\0\u6f54\0\u6f8d\0\u6fc6"+
    "\0\u6fff\0\u7038\0\u7071\0\u70aa\0\u70e3\0\u711c\0\u7155\0\u718e"+
    "\0\u71c7\0\u7200\0\u7239\0\u7272\0\u72ab\0\u72e4\0\u731d\0\u7356"+
    "\0\u738f\0\u73c8\0\u7401\0\u743a\0\u7473\0\u74ac\0\u74e5\0\u751e"+
    "\0\u7557\0\u7590\0\u75c9\0\u7602\0\u763b\0\u7674\0\u76ad\0\u76e6"+
    "\0\u771f\0\u7758\0\u7791\0\u77ca\0\u7803\0\u783c\0\u7875\0\u78ae"+
    "\0\u78e7\0\u7920\0\u7959\0\u7992\0\u79cb\0\u7a04\0\u7a3d\0\u7a76"+
    "\0\u7aaf\0\u7ae8\0\u7b21\0\u7b5a\0\u7b93\0\u7bcc\0\u7c05\0\u7c3e"+
    "\0\u7c77\0\u7cb0\0\u7ce9\0\u7d22\0\u7d5b\0\u7d94\0\u7dcd\0\u7e06"+
    "\0\u7e3f\0\u7e78\0\u7eb1\0\u7eea\0\u7f23\0\u7f5c\0\u7f95\0\u7fce"+
    "\0\u8007\0\u8040\0\u8079\0\u80b2\0\u80eb\0\u8124\0\u815d\0\u8196"+
    "\0\u81cf\0\u8208\0\u8241\0\u827a\0\u82b3\0\u82ec\0\u8325\0\u835e"+
    "\0\u8397\0\u83d0\0\u8409\0\u8442\0\u847b\0\u84b4\0\u84ed\0\u8526"+
    "\0\u855f\0\u8598\0\u85d1\0\u860a\0\u8643\0\u867c\0\u86b5\0\u86ee"+
    "\0\u8727\0\u8760\0\u8799\0\u87d2\0\u880b\0\u8844\0\u887d\0\u88b6"+
    "\0\u88ef\0\u8928\0\u8961\0\u899a\0\u89d3\0\u8a0c\0\u8a45\0\u8a7e"+
    "\0\u8ab7\0\u8af0\0\u8b29\0\u8b62\0\u8b9b\0\u8bd4\0\u8c0d\0\u8c46"+
    "\0\u8c7f\0\u8cb8\0\u8cf1\0\u8d2a\0\u8d63\0\u8d9c\0\u8dd5\0\u8e0e"+
    "\0\u8e47\0\u8e80\0\u8eb9\0\u8ef2\0\u8f2b\0\u8f64\0\u8f9d\0\u8fd6"+
    "\0\u900f\0\u9048\0\u9081\0\u90ba\0\u90f3\0\u912c\0\u9165\0\u919e"+
    "\0\u91d7\0\u9210\0\u9249\0\u9282\0\u92bb\0\u92f4\0\u932d\0\u9366"+
    "\0\u939f\0\u93d8\0\u9411\0\u944a\0\u9483\0\u94bc\0\u94f5\0\u952e"+
    "\0\u9567\0\u95a0\0\u95d9\0\u9612\0\u964b\0\u9684\0\u96bd\0\u96f6"+
    "\0\u972f\0\u9768\0\u97a1\0\u97da\0\u9813\0\u984c\0\u9885\0\u98be"+
    "\0\u98f7\0\u9930\0\u9969\0\u99a2\0\u99db\0\u9a14\0\u9a4d\0\u9a86"+
    "\0\u9abf\0\u9af8\0\u9b31\0\u9b6a\0\u9ba3\0\u9bdc\0\u9c15\0\u9c4e"+
    "\0\u9c87\0\u9cc0\0\u9cf9\0\u9d32\0\u9d6b\0\u9da4\0\u9ddd\0\u9e16"+
    "\0\u9e4f\0\u9e88\0\u9ec1\0\u9efa\0\u9f33\0\u9f6c\0\u9fa5\0\u9fde"+
    "\0\ua017\0\ua050\0\ua089\0\ua0c2\0\ua0fb\0\ua134\0\ua16d\0\ua1a6"+
    "\0\ua1df\0\ua218\0\ua251\0\ua28a\0\ua2c3\0\ua2fc\0\ua335\0\ua36e"+
    "\0\ua3a7\0\ua3e0\0\ua419\0\ua452\0\ua48b\0\ua4c4\0\ua4fd\0\ua536"+
    "\0\ua56f\0\ua5a8\0\ua5e1\0\ua61a\0\ua653\0\ua68c\0\ua6c5\0\ua6fe"+
    "\0\ua737\0\ua770\0\ua7a9\0\ua7e2\0\ua81b\0\ua854\0\ua88d\0\ua8c6"+
    "\0\ua8ff\0\ua938\0\ua971\0\ua9aa\0\ua9e3\0\uaa1c\0\uaa55\0\uaa8e"+
    "\0\uaac7\0\uab00\0\uab39\0\uab72\0\uabab\0\uabe4\0\uac1d\0\uac56"+
    "\0\uac8f\0\uacc8\0\uad01\0\uad3a\0\uad73\0\uadac\0\uade5\0\uae1e"+
    "\0\uae57\0\uae90\0\uaec9\0\uaf02\0\uaf3b\0\uaf74\0\uafad\0\uafe6"+
    "\0\ub01f\0\ub058\0\ub091\0\ub0ca\0\ub103\0\ub13c\0\ub175\0\ub1ae"+
    "\0\ub1e7\0\ub220\0\ub259\0\ub292\0\ub2cb\0\ub304\0\ub33d\0\ub376"+
    "\0\ub3af\0\ub3e8\0\ub421\0\ub45a\0\ub493\0\ub4cc\0\ub505\0\u6186"+
    "\0\ub53e\0\ub577\0\ub5b0\0\ub5e9\0\ub622\0\ub65b\0\ub694\0\ub6cd"+
    "\0\ub706\0\ub73f\0\ub778\0\ub7b1\0\ub7ea\0\ub823\0\ub85c\0\ub895"+
    "\0\ub73f\0\ub8ce\0\ub907\0\ub940\0\ub979\0\ub9b2\0\ub9eb\0\uba24"+
    "\0\uba5d\0\uba96\0\ubacf\0\ubb08\0\ubb41\0\ubb7a\0\ubbb3\0\ubbec"+
    "\0\ubc25\0\uba96\0\ubc5e\0\ubc97\0\ubcd0\0\ubd09\0\ubd42\0\ubd7b"+
    "\0\ubdb4\0\ubded\0\ube26\0\ube5f\0\ube98\0\ubed1\0\ubf0a\0\ubf43"+
    "\0\ubf7c\0\ubfb5\0\ubfee\0\uc027\0\uc060\0\uc099\0\uc0d2\0\uc10b"+
    "\0\uc144\0\uc17d\0\uc1b6\0\uc1ef\0\uc228\0\uc099\0\uc261\0\uc29a"+
    "\0\uc2d3\0\uc30c\0\uc345\0\uc37e\0\uc3b7\0\uc3f0\0\uc429\0\uc462"+
    "\0\uc49b\0\uc4d4\0\uc50d\0\uc546\0\uc57f\0\uc5b8\0\uc5f1\0\uc62a"+
    "\0\uc663\0\uc69c\0\uc6d5\0\uc70e\0\uc747\0\uc780\0\uc7b9\0\uc7f2"+
    "\0\uc82b\0\uc864\0\uc89d\0\uc8d6\0\uc90f\0\uc948\0\uc981\0\uc9ba"+
    "\0\uc9f3\0\uca2c\0\uca65\0\uca9e\0\ucad7\0\ucb10\0\ucb49\0\ucb82"+
    "\0\ucbbb\0\ucbf4\0\ucc2d\0\ucc66\0\ucc9f\0\uccd8\0\ucd11\0\ucd4a"+
    "\0\ucd83\0\ucdbc\0\ucdf5\0\uce2e\0\uce67\0\ucea0\0\uced9\0\ucf12"+
    "\0\ucf4b\0\ucf84\0\ucfbd\0\ucff6\0\ud02f\0\ud068\0\ud0a1\0\ud0da"+
    "\0\ud113\0\ud14c\0\ud185\0\ud1be\0\ud1f7\0\ud230\0\ud269\0\ud2a2"+
    "\0\ud2db\0\ud314\0\ud34d\0\ud386\0\ud3bf\0\ud3f8\0\ud431\0\ud46a"+
    "\0\ud4a3\0\ud4dc\0\ud515\0\ud54e\0\ud587\0\ud5c0\0\ud5f9\0\ud632"+
    "\0\ud66b\0\ud6a4\0\ud6dd\0\ud716\0\ud74f\0\ud788\0\ud7c1\0\ud7fa"+
    "\0\ud833\0\ud86c\0\ud8a5\0\ud8de\0\ud917\0\ud950\0\ud989\0\ud9c2"+
    "\0\ud9fb\0\uda34\0\uda6d\0\udaa6\0\udadf\0\udb18\0\udb51\0\udb8a"+
    "\0\udbc3\0\udbfc\0\udc35\0\udc6e\0\udca7\0\udce0\0\udd19\0\udd52"+
    "\0\udd8b\0\uddc4\0\uddfd\0\ude36\0\ude6f\0\udea8\0\udee1\0\udf1a"+
    "\0\udf53\0\udf8c\0\udfc5\0\udffe\0\ue037\0\ue070\0\ue0a9\0\ue0e2"+
    "\0\ue11b\0\ue154\0\ue18d\0\ue1c6\0\ue1ff\0\ue238\0\ue271\0\ue2aa"+
    "\0\ue2e3\0\ue31c\0\ue355\0\ue38e\0\ue3c7\0\ue400\0\ue439\0\ue472"+
    "\0\ue4ab\0\ue4e4\0\ue51d\0\ue556\0\ue58f\0\ue5c8\0\ue601\0\ue63a"+
    "\0\ue673\0\ue6ac\0\ue6e5\0\ue71e\0\ue757\0\ue790\0\ue7c9\0\ue802"+
    "\0\ue83b\0\ue874\0\ue8ad\0\ue8e6\0\ue91f\0\ue958\0\ue991\0\ue9ca"+
    "\0\uea03\0\uea3c\0\uea75\0\ueaae\0\ueae7\0\ueb20\0\ueb59\0\ueb92"+
    "\0\uebcb\0\uec04\0\uec3d\0\uec76\0\uecaf\0\uece8\0\ueb20\0\ued21"+
    "\0\ued5a\0\ued93\0\uedcc\0\uee05\0\uee3e\0\uee77\0\ueeb0\0\ueee9"+
    "\0\uef22\0\uef5b\0\uef94\0\uefcd\0\uf006\0\uee05\0\uf03f\0\uf078"+
    "\0\uf0b1\0\uee77\0\uf0ea\0\uf123\0\uf15c\0\uef22\0\uf195\0\uf1ce"+
    "\0\uf207\0\uf240\0\uf279\0\uf2b2\0\uf2eb\0\uf324\0\uf35d\0\uf396"+
    "\0\uf3cf\0\uf408\0\uf441\0\uf47a\0\uf4b3\0\uf4ec\0\uf525\0\uf55e"+
    "\0\uf597\0\uf5d0\0\uf609\0\uf642\0\uf67b\0\uf6b4\0\uf6ed\0\uf726"+
    "\0\uf75f\0\uf798\0\uf7d1\0\uf80a\0\uf843\0\uf87c\0\uf8b5\0\uf8ee"+
    "\0\uf927\0\uf960\0\uf999\0\uf9d2\0\ufa0b\0\ufa44\0\ufa7d\0\ufab6"+
    "\0\ufaef\0\ufb28\0\ufb61\0\ufb9a\0\ufbd3\0\ufc0c\0\ufc45\0\ufc7e"+
    "\0\ufcb7\0\ufcf0\0\ufd29\0\ufd62\0\ufd9b\0\ufb61\0\ufdd4\0\ufe0d"+
    "\0\ufe46\0\ufc0c\0\ufe7f\0\ufeb8\0\ufef1\0\uff2a\0\uff63\0\uff9c"+
    "\0\uffd5\1\16\1\107\1\200\1\271\1\362\1\u012b\1\u0164"+
    "\1\u019d\1\u01d6\1\u020f\1\u0248\1\u0281\1\u02ba\1\u02f3\1\u032c"+
    "\1\u0365\1\u039e\1\u03d7\1\u0410\1\u0449\1\u0482\1\u04bb\1\u04f4"+
    "\1\u052d\1\u0566\1\u059f\1\u05d8\1\u0611\1\u064a\1\u0683\1\u06bc"+
    "\1\u06f5\1\u072e\1\u0767\1\u07a0\1\u07d9\1\u0812\1\u084b\1\u0884"+
    "\1\u08bd\1\u08f6\1\u092f\1\u0968\1\u09a1\1\u09da\1\u0a13\1\u0a4c"+
    "\1\u0a85\1\u0abe\1\u0af7\1\u0b30\1\u0b69\1\u0ba2\1\u0bdb\1\u0c14"+
    "\1\u0c4d\1\u0c86\1\u0cbf\1\u0cf8\1\u0d31\1\u0d6a\1\u0da3\1\u0ddc"+
    "\1\u0e15\1\u0e4e\1\u0e87\1\u0ec0\1\u0ef9\1\u0f32\1\u0f6b\1\u0fa4"+
    "\1\u0fdd\1\u1016\1\u104f\1\u1088\1\u10c1\1\u10fa\1\u1133\1\u116c"+
    "\1\u11a5\1\u11de\1\u1217\1\u1250\1\u1289\1\u12c2\1\u12fb\1\u1334"+
    "\1\u136d\1\u13a6\1\u13df\1\u1418\1\u1451\1\u148a\1\u14c3\1\u14fc"+
    "\1\u1535\1\u156e\1\u15a7\1\u15e0\1\u1619\1\u1652\1\u168b\1\u16c4"+
    "\1\u16fd\1\u1736\1\u176f\1\u17a8\1\u17e1\1\u181a\1\u1853\1\u188c"+
    "\1\u18c5\1\u18fe\1\u1937\1\u1970\1\u19a9\1\u19e2\1\u1a1b\1\u1a54"+
    "\1\u1a8d\1\u1ac6\1\u1aff\1\u1b38\1\u1b71\1\u1baa\1\u1be3\1\u1c1c"+
    "\0\253\1\u1c55\1\u1c8e\1\u1cc7\1\u1d00\1\u1d39\1\u1d72\1\u1dab"+
    "\1\u1de4\1\u1e1d\1\u1e56\1\u1e8f\1\u1ec8\1\u1f01\1\u1f3a\1\u1f73"+
    "\1\u1fac\1\u1fe5\1\u201e\1\u2057\1\u2090\1\u20c9\1\u2102\1\u213b"+
    "\1\u2174\1\u21ad\1\u21e6\1\u221f\1\u2174\1\u2258\1\u2291\1\u22ca"+
    "\1\u2303\1\u233c\1\u2375\1\u23ae\1\u23e7\1\u2420\1\u2459\1\u2492"+
    "\1\u24cb\1\u2504\1\u253d\1\u2576\1\u25af\1\u25e8\1\u2576\1\u2621"+
    "\1\u265a\1\u2693\1\u26cc\1\u2705\1\u273e\1\u2777\1\u27b0\1\u27e9"+
    "\1\u2822\1\u285b\1\u2894\1\u28cd\1\u2906\1\u293f\1\u2978\1\u29b1"+
    "\1\u29ea\1\u2a23\1\u2a5c\1\u2a95\1\u2ace\1\u2b07\1\u2b40\1\u2b79"+
    "\1\u2bb2\1\u2beb\1\u2c24\1\u2c5d\1\u2c96\1\u2ccf\1\u2d08\1\u2d41"+
    "\1\u2d7a\1\u2db3\1\u2dec\1\u2e25\1\u2e5e\1\u2e97\1\u2ed0\1\u2f09"+
    "\1\u2f42\1\u2f7b\1\u2fb4\1\u2fed\1\u3026\1\u305f\1\u3098";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[1399];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\40\4\1\5\30\4\40\6\1\7\30\6\40\10\1\11"+
    "\30\10\115\0\1\12\30\0\1\12\20\0\1\13\107\0"+
    "\1\14\30\0\1\14\36\0\1\15\30\0\1\15\40\0"+
    "\1\16\30\0\1\16\36\0\1\17\30\0\1\17\42\0"+
    "\1\20\30\0\1\20\34\0\1\21\30\0\1\21\42\0"+
    "\1\22\30\0\1\22\20\0\1\23\107\0\1\24\30\0"+
    "\1\24\20\0\1\25\72\0\1\26\2\27\1\30\2\27"+
    "\1\31\4\27\1\32\13\27\2\0\1\27\1\33\2\0"+
    "\1\34\2\0\1\35\3\0\1\36\24\0\1\37\2\0"+
    "\1\40\1\0\1\41\1\42\4\0\1\43\1\0\1\44"+
    "\3\0\1\45\4\0\1\46\3\0\1\37\2\0\1\40"+
    "\1\0\1\41\1\42\3\0\1\43\1\0\1\44\3\0"+
    "\1\45\4\0\1\46\7\0\1\47\1\0\23\27\1\50"+
    "\3\27\2\0\1\27\22\0\1\51\12\0\1\47\1\0"+
    "\27\27\2\0\1\27\35\0\1\47\1\0\16\27\1\52"+
    "\10\27\2\0\1\27\15\0\1\53\17\0\1\47\1\0"+
    "\23\27\1\54\3\27\2\0\1\27\22\0\1\55\12\0"+
    "\1\47\1\0\4\27\1\56\22\27\2\0\1\27\4\0"+
    "\1\57\55\0\1\51\30\0\1\51\32\0\1\53\30\0"+
    "\1\53\44\0\1\55\30\0\1\55\20\0\1\57\31\0"+
    "\1\57\55\0\1\60\30\0\1\60\32\0\1\61\30\0"+
    "\1\61\44\0\1\62\30\0\1\62\37\0\1\63\30\0"+
    "\1\63\20\0\1\64\31\0\1\64\55\0\1\65\30\0"+
    "\1\65\36\0\1\66\30\0\1\66\21\0\1\67\31\0"+
    "\1\67\21\0\2\47\2\0\3\47\1\70\30\47\2\0"+
    "\27\47\7\0\1\47\1\0\22\27\1\71\4\27\2\0"+
    "\1\27\21\0\1\72\37\0\1\72\30\0\1\72\13\0"+
    "\1\47\1\0\2\27\1\73\24\27\2\0\1\27\2\0"+
    "\1\74\36\0\1\74\31\0\1\74\32\0\1\47\1\0"+
    "\27\27\2\0\1\75\70\0\1\76\35\0\1\47\1\0"+
    "\6\27\1\77\20\27\2\0\1\27\6\0\1\100\36\0"+
    "\1\100\31\0\1\100\52\0\1\101\30\0\1\101\17\0"+
    "\1\102\31\0\1\102\47\0\1\103\30\0\1\103\55\0"+
    "\1\104\45\0\1\105\31\0\1\105\44\0\1\106\30\0"+
    "\1\106\42\0\1\107\30\0\1\107\20\0\1\110\31\0"+
    "\1\110\33\0\1\111\71\0\1\47\1\0\7\27\1\112"+
    "\17\27\2\0\1\27\7\0\1\113\36\0\1\113\31\0"+
    "\1\113\25\0\1\47\1\0\22\27\1\114\4\27\2\0"+
    "\1\27\21\0\1\115\37\0\1\115\30\0\1\115\13\0"+
    "\1\47\1\0\1\116\26\27\2\0\1\27\1\117\36\0"+
    "\1\117\31\0\1\117\34\0\1\47\1\0\27\27\2\0"+
    "\1\120\70\0\1\121\46\0\1\122\31\0\1\122\51\0"+
    "\1\123\6\0\1\124\21\0\1\123\30\0\1\125\30\0"+
    "\1\125\24\0\1\126\31\0\1\126\67\0\1\127\40\0"+
    "\1\130\31\0\1\130\62\0\1\131\30\0\1\131\32\0"+
    "\1\132\30\0\1\132\14\0\1\111\32\0\1\133\36\0"+
    "\1\134\1\0\27\27\2\0\1\27\35\0\1\135\70\0"+
    "\1\47\1\0\26\27\1\136\2\0\1\27\25\0\1\137"+
    "\37\0\1\137\30\0\1\137\7\0\1\47\1\0\22\27"+
    "\1\140\4\27\2\0\1\27\21\0\1\141\37\0\1\141"+
    "\30\0\1\141\13\0\1\47\1\0\1\26\2\27\1\30"+
    "\23\27\2\0\1\27\1\33\2\0\1\34\33\0\1\33"+
    "\2\0\1\34\26\0\1\33\2\0\1\34\31\0\1\142"+
    "\120\0\1\143\30\0\1\143\14\0\1\144\31\0\1\144"+
    "\64\0\1\145\61\0\1\146\30\0\1\146\15\0\1\37"+
    "\2\0\1\147\26\0\1\37\2\0\1\147\37\0\1\150"+
    "\31\0\1\150\30\0\1\151\70\0\1\152\61\0\2\47"+
    "\2\0\3\47\1\70\3\47\1\153\10\47\1\154\3\47"+
    "\1\155\1\156\6\47\2\0\3\47\1\153\7\47\1\154"+
    "\3\47\1\155\1\156\6\47\13\0\1\157\10\0\1\160"+
    "\3\0\1\161\1\162\13\0\1\157\7\0\1\160\3\0"+
    "\1\161\1\162\15\0\1\47\1\0\17\27\1\163\7\27"+
    "\2\0\1\27\16\0\1\164\37\0\1\164\30\0\1\164"+
    "\16\0\1\47\1\0\22\27\1\165\4\27\2\0\1\27"+
    "\21\0\1\166\37\0\1\166\30\0\1\166\17\0\1\167"+
    "\10\0\1\170\3\0\1\171\1\172\13\0\1\167\7\0"+
    "\1\170\3\0\1\171\1\172\36\0\1\173\30\0\1\173"+
    "\20\0\1\174\31\0\1\174\53\0\1\175\30\0\1\175"+
    "\44\0\1\110\30\0\1\110\33\0\1\176\30\0\1\176"+
    "\41\0\1\177\30\0\1\177\6\0\2\151\2\0\3\151"+
    "\1\200\30\151\2\0\27\151\2\152\2\0\3\152\1\201"+
    "\30\152\2\0\27\152\2\47\2\0\3\47\1\70\1\47"+
    "\1\202\26\47\2\0\1\47\1\202\27\47\2\0\3\47"+
    "\1\70\24\47\1\203\3\47\2\0\23\47\1\203\5\47"+
    "\2\0\3\47\1\70\21\47\1\204\6\47\2\0\20\47"+
    "\1\204\10\47\2\0\3\47\1\70\5\47\1\205\22\47"+
    "\2\0\5\47\1\205\21\47\11\0\1\206\31\0\1\206"+
    "\61\0\1\207\30\0\1\207\34\0\1\210\30\0\1\210"+
    "\23\0\1\211\31\0\1\211\30\0\1\47\1\0\4\27"+
    "\1\212\22\27\2\0\1\27\4\0\1\213\36\0\1\213"+
    "\31\0\1\213\30\0\1\47\1\0\20\27\1\214\6\27"+
    "\2\0\1\27\17\0\1\215\37\0\1\215\30\0\1\215"+
    "\17\0\1\216\31\0\1\216\61\0\1\217\30\0\1\217"+
    "\34\0\1\220\30\0\1\220\23\0\1\221\31\0\1\221"+
    "\36\0\1\222\31\0\1\222\54\0\1\223\30\0\1\223"+
    "\40\0\1\224\30\0\1\224\16\0\1\225\31\0\1\225"+
    "\32\0\1\152\32\0\1\226\34\0\1\227\70\0\1\230"+
    "\62\0\2\47\2\0\3\47\1\70\20\47\1\231\7\47"+
    "\2\0\17\47\1\231\11\47\2\0\3\47\1\70\17\47"+
    "\1\232\10\47\2\0\16\47\1\232\12\47\2\0\3\47"+
    "\1\70\5\47\1\233\22\47\2\0\5\47\1\233\23\47"+
    "\2\0\3\47\1\234\30\47\2\0\27\47\30\0\1\235"+
    "\30\0\1\235\36\0\1\236\30\0\1\236\25\0\1\237"+
    "\31\0\1\237\30\0\1\240\70\0\1\241\1\0\27\27"+
    "\2\0\1\27\35\0\1\242\70\0\1\243\1\0\27\27"+
    "\2\0\1\27\35\0\1\244\111\0\1\245\30\0\1\245"+
    "\36\0\1\246\30\0\1\246\25\0\1\247\31\0\1\247"+
    "\30\0\1\250\70\0\1\251\76\0\1\252\31\0\1\252"+
    "\46\0\1\253\30\0\1\253\45\0\1\123\30\0\1\123"+
    "\43\0\1\46\30\0\1\46\6\0\1\227\32\0\1\254"+
    "\35\0\1\230\32\0\1\255\27\0\2\47\2\0\3\47"+
    "\1\70\17\47\1\256\10\47\2\0\16\47\1\256\12\47"+
    "\2\0\3\47\1\70\7\47\1\257\20\47\2\0\7\47"+
    "\1\257\21\47\2\0\3\47\1\70\22\47\1\260\5\47"+
    "\2\0\21\47\1\260\5\47\6\0\1\261\111\0\1\262"+
    "\30\0\1\262\27\0\1\263\31\0\1\263\51\0\1\264"+
    "\30\0\1\264\13\0\1\265\62\0\2\47\2\0\3\47"+
    "\1\70\4\47\1\266\2\47\1\267\4\47\1\270\2\47"+
    "\1\271\10\47\2\0\4\47\1\266\2\47\1\267\3\47"+
    "\1\270\2\47\1\271\10\47\14\0\1\272\2\0\1\273"+
    "\4\0\1\274\2\0\1\275\16\0\1\272\2\0\1\273"+
    "\3\0\1\274\2\0\1\275\10\0\2\243\2\0\3\243"+
    "\1\276\30\243\2\0\27\243\2\244\2\0\3\244\1\277"+
    "\30\244\2\0\27\244\27\0\1\300\30\0\1\300\27\0"+
    "\1\301\31\0\1\301\51\0\1\302\30\0\1\302\13\0"+
    "\1\303\76\0\1\304\2\0\1\305\4\0\1\306\2\0"+
    "\1\307\3\0\1\305\12\0\1\304\2\0\1\305\3\0"+
    "\1\306\2\0\1\307\3\0\1\305\13\0\1\310\73\0"+
    "\1\311\31\0\1\311\24\0\40\312\1\0\30\312\40\313"+
    "\1\0\30\313\2\47\2\0\3\47\1\70\30\47\2\0"+
    "\1\314\30\47\2\0\3\47\1\70\17\47\1\315\10\47"+
    "\2\0\16\47\1\315\12\47\2\0\3\47\1\70\30\47"+
    "\2\0\1\316\26\47\6\0\1\261\32\0\1\317\71\0"+
    "\1\320\55\0\1\321\30\0\1\321\52\0\1\322\34\0"+
    "\1\265\32\0\1\323\27\0\2\47\2\0\3\47\1\70"+
    "\5\47\1\324\6\47\1\325\13\47\2\0\5\47\1\324"+
    "\5\47\1\325\15\47\2\0\3\47\1\70\24\47\1\326"+
    "\3\47\2\0\23\47\1\326\5\47\2\0\3\47\1\327"+
    "\3\47\1\330\24\47\2\0\3\47\1\330\25\47\2\0"+
    "\3\47\1\70\21\47\1\331\6\47\2\0\20\47\1\331"+
    "\6\47\15\0\1\332\6\0\1\333\22\0\1\332\5\0"+
    "\1\333\47\0\1\334\30\0\1\334\12\0\1\335\3\0"+
    "\1\336\31\0\1\336\54\0\1\337\30\0\1\337\14\0"+
    "\1\340\70\0\1\341\124\0\1\342\55\0\1\343\30\0"+
    "\1\343\52\0\1\344\34\0\1\303\32\0\1\345\44\0"+
    "\1\346\6\0\1\347\22\0\1\346\5\0\1\347\47\0"+
    "\1\221\30\0\1\221\12\0\1\250\3\0\1\221\31\0"+
    "\1\221\54\0\1\350\30\0\1\350\6\0\2\310\2\0"+
    "\3\310\1\250\30\310\2\0\27\310\15\0\1\110\31\0"+
    "\1\110\21\0\40\312\1\351\30\312\40\313\1\352\30\313"+
    "\2\47\2\0\3\47\1\70\7\47\1\353\10\47\1\354"+
    "\7\47\2\0\7\47\1\353\7\47\1\354\11\47\2\0"+
    "\3\47\1\70\23\47\1\355\4\47\2\0\22\47\1\355"+
    "\6\47\2\0\3\47\1\70\3\47\1\356\15\47\1\357"+
    "\6\47\2\0\3\47\1\356\14\47\1\357\6\47\40\360"+
    "\1\0\30\360\17\0\1\361\10\0\1\362\20\0\1\361"+
    "\7\0\1\362\42\0\1\363\30\0\1\363\17\0\1\364"+
    "\15\0\1\365\13\0\1\364\14\0\1\365\6\0\2\47"+
    "\2\0\3\47\1\70\3\47\1\366\24\47\2\0\3\47"+
    "\1\366\25\47\2\0\3\47\1\367\7\47\1\370\20\47"+
    "\2\0\7\47\1\370\21\47\2\0\3\47\1\371\30\47"+
    "\2\0\27\47\6\0\1\372\62\0\2\47\2\0\3\47"+
    "\1\327\30\47\2\0\31\47\2\0\3\47\1\70\4\47"+
    "\1\373\23\47\2\0\4\47\1\373\22\47\13\0\1\374"+
    "\31\0\1\374\32\0\1\375\7\0\1\376\31\0\1\376"+
    "\26\0\1\377\67\0\1\u0100\71\0\1\335\75\0\1\u0101"+
    "\31\0\1\u0101\30\0\1\340\32\0\1\u0102\35\0\1\341"+
    "\32\0\1\u0103\46\0\1\u0104\10\0\1\u0105\20\0\1\u0104"+
    "\7\0\1\u0105\42\0\1\u0106\30\0\1\u0106\17\0\1\u0107"+
    "\15\0\1\u0108\13\0\1\u0107\14\0\1\u0108\6\0\40\u0109"+
    "\1\0\30\u0109\13\0\1\u010a\31\0\1\u010a\32\0\1\250"+
    "\7\0\1\u010b\31\0\1\u010b\33\0\1\221\31\0\1\221"+
    "\27\0\1\u010c\70\0\1\u010d\63\0\2\47\2\0\3\47"+
    "\1\70\17\47\1\u010e\10\47\2\0\16\47\1\u010e\12\47"+
    "\2\0\3\47\1\70\21\47\1\u010f\6\47\2\0\20\47"+
    "\1\u010f\10\47\2\0\3\47\1\70\5\47\1\u0110\22\47"+
    "\2\0\5\47\1\u0110\23\47\2\0\3\47\1\70\17\47"+
    "\1\u0111\10\47\2\0\16\47\1\u0111\12\47\2\0\3\47"+
    "\1\70\5\47\1\u0112\22\47\2\0\5\47\1\u0112\21\47"+
    "\40\360\1\u0113\30\360\27\0\1\u0114\30\0\1\u0114\41\0"+
    "\1\u0115\30\0\1\u0115\23\0\1\u0116\31\0\1\u0116\50\0"+
    "\1\u0117\30\0\1\u0117\25\0\1\u0118\31\0\1\u0118\21\0"+
    "\2\47\2\0\3\47\1\70\21\47\1\u0119\6\47\2\0"+
    "\20\47\1\u0119\6\47\6\0\1\u011a\62\0\2\47\2\0"+
    "\3\47\1\70\22\47\1\u011b\5\47\2\0\21\47\1\u011b"+
    "\5\47\6\0\1\u011c\70\0\1\372\32\0\1\u011d\27\0"+
    "\2\47\2\0\3\47\1\u011e\30\47\2\0\27\47\31\0"+
    "\1\u011f\30\0\1\u011f\14\0\1\u0120\114\0\1\u0121\30\0"+
    "\1\u0121\13\0\1\u0122\70\0\1\u0100\32\0\1\u0123\36\0"+
    "\1\u0124\61\0\40\u0125\1\0\30\u0125\27\0\1\u0126\30\0"+
    "\1\u0126\41\0\1\u0127\30\0\1\u0127\23\0\1\u0128\31\0"+
    "\1\u0128\50\0\1\u0129\30\0\1\u0129\25\0\1\u012a\31\0"+
    "\1\u012a\21\0\40\u0109\1\u012b\30\u0109\31\0\1\221\30\0"+
    "\1\221\40\0\1\221\30\0\1\221\31\0\1\u012c\30\0"+
    "\1\u012c\37\0\1\u012d\30\0\1\u012d\13\0\2\47\2\0"+
    "\3\47\1\70\25\47\1\u012e\2\47\2\0\24\47\1\u012e"+
    "\4\47\2\0\3\47\1\70\17\47\1\u012f\10\47\2\0"+
    "\16\47\1\u012f\12\47\2\0\3\47\1\70\16\47\1\u0130"+
    "\11\47\2\0\15\47\1\u0130\13\47\2\0\3\47\1\70"+
    "\16\47\1\u0131\11\47\2\0\15\47\1\u0131\13\47\2\0"+
    "\3\47\1\70\20\47\1\u0132\7\47\2\0\17\47\1\u0132"+
    "\7\47\5\0\1\u0133\120\0\1\u0134\30\0\1\u0134\31\0"+
    "\1\u0135\30\0\1\u0135\36\0\1\u0136\30\0\1\u0136\37\0"+
    "\1\u0137\30\0\1\u0137\41\0\1\u0138\30\0\1\u0138\7\0"+
    "\2\47\2\0\3\47\1\u0139\30\47\2\0\27\47\6\0"+
    "\1\u011a\32\0\1\u013a\27\0\2\47\2\0\3\47\1\367"+
    "\30\47\2\0\27\47\6\0\1\u011c\32\0\1\u013b\27\0"+
    "\40\u013c\1\0\30\u013c\6\0\1\u013d\71\0\1\u013e\67\0"+
    "\1\u0120\32\0\1\u013f\36\0\1\375\67\0\1\u0122\32\0"+
    "\1\u0140\35\0\1\u0141\62\0\40\u0125\1\u0142\30\u0125\35\0"+
    "\1\221\30\0\1\221\31\0\1\u0143\30\0\1\u0143\36\0"+
    "\1\u0144\30\0\1\u0144\37\0\1\u0145\30\0\1\u0145\41\0"+
    "\1\221\30\0\1\221\14\0\1\u0146\106\0\1\u0147\30\0"+
    "\1\u0147\37\0\1\u0148\30\0\1\u0148\14\0\2\47\2\0"+
    "\3\47\1\u0149\30\47\2\0\31\47\2\0\3\47\1\70"+
    "\25\47\1\u014a\2\47\2\0\24\47\1\u014a\4\47\2\0"+
    "\3\47\1\70\5\47\1\u014b\22\47\2\0\5\47\1\u014b"+
    "\23\47\2\0\3\47\1\70\22\47\1\u014c\5\47\2\0"+
    "\21\47\1\u014c\7\47\2\0\3\47\1\u014d\30\47\2\0"+
    "\27\47\24\0\1\u014e\30\0\1\u014e\22\0\1\u014f\116\0"+
    "\1\u0150\30\0\1\u0150\17\0\1\u0151\31\0\1\u0151\53\0"+
    "\1\u0152\30\0\1\u0152\14\0\1\u0153\67\0\1\u0154\62\0"+
    "\40\u0155\1\0\30\u0155\40\u0156\1\0\30\u0156\40\u013c\1\u0157"+
    "\30\u013c\6\0\1\u013d\32\0\1\u0158\35\0\1\u0159\70\0"+
    "\1\u0141\32\0\1\u015a\34\0\1\u015b\120\0\1\u015c\30\0"+
    "\1\u015c\17\0\1\u015d\31\0\1\u015d\53\0\1\u015e\30\0"+
    "\1\u015e\31\0\1\u015f\30\0\1\u015f\41\0\1\u0160\30\0"+
    "\1\u0160\37\0\1\u0161\30\0\1\u0161\17\0\1\u0162\62\0"+
    "\2\47\2\0\3\47\1\70\25\47\1\u0163\2\47\2\0"+
    "\24\47\1\u0163\4\47\2\0\3\47\1\70\16\47\1\u0164"+
    "\11\47\2\0\15\47\1\u0164\13\47\2\0\3\47\1\70"+
    "\30\47\2\0\1\u0165\26\47\6\0\1\u0166\105\0\1\u0167"+
    "\30\0\1\u0167\22\0\1\u0168\117\0\1\u0169\30\0\1\u0169"+
    "\30\0\1\u016a\30\0\1\u016a\53\0\1\u016b\34\0\1\u016c"+
    "\70\0\1\u0154\32\0\1\u016d\27\0\40\u0155\1\u016e\30\u0155"+
    "\40\u0156\1\u016f\30\u0156\5\0\1\u0170\63\0\40\u0171\1\0"+
    "\30\u0171\6\0\1\u0159\32\0\1\u0172\53\0\1\u0173\30\0"+
    "\1\u0173\50\0\1\u0174\30\0\1\u0174\30\0\1\u0175\30\0"+
    "\1\u0175\53\0\1\u0176\51\0\1\u0177\30\0\1\u0177\55\0"+
    "\1\u0178\70\0\1\u0179\35\0\1\u0162\32\0\1\u017a\27\0"+
    "\2\47\2\0\3\47\1\70\30\47\2\0\1\u017b\30\47"+
    "\2\0\3\47\1\70\23\47\1\u017c\4\47\2\0\22\47"+
    "\1\u017c\6\47\2\0\3\47\1\70\15\47\1\u017d\12\47"+
    "\2\0\14\47\1\u017d\12\47\6\0\1\u0166\32\0\1\u017e"+
    "\55\0\1\u017f\30\0\1\u017f\17\0\1\u0168\32\0\1\u0180"+
    "\71\0\1\u0181\61\0\1\u0182\30\0\1\u0182\31\0\1\u0183"+
    "\30\0\1\u0183\20\0\1\u016c\32\0\1\u0184\27\0\40\u0185"+
    "\1\0\30\u0185\5\0\1\u0186\70\0\1\u0187\107\0\1\u0188"+
    "\30\0\1\u0188\13\0\40\u0171\1\u0189\30\u0171\23\0\1\u018a"+
    "\30\0\1\u018a\56\0\1\u018b\61\0\1\172\30\0\1\172"+
    "\31\0\1\u018c\30\0\1\u018c\40\0\1\u018d\30\0\1\u018d"+
    "\11\0\40\u018e\1\0\30\u018e\2\47\2\0\3\47\1\70"+
    "\22\47\1\u018f\5\47\2\0\21\47\1\u018f\7\47\2\0"+
    "\3\47\1\70\5\47\1\u012e\22\47\2\0\5\47\1\u012e"+
    "\23\47\2\0\3\47\1\70\11\47\1\u0190\16\47\2\0"+
    "\11\47\1\u0190\15\47\40\u0191\1\0\30\u0191\41\0\1\u0192"+
    "\61\0\1\u0193\30\0\1\u0193\22\0\1\u0134\31\0\1\u0134"+
    "\42\0\1\u0194\31\0\1\u0194\15\0\40\u0185\1\u0195\30\u0185"+
    "\24\0\1\u0196\30\0\1\u0196\37\0\1\u0197\30\0\1\u0197"+
    "\36\0\1\u0198\30\0\1\u0198\21\0\1\u0199\111\0\1\u019a"+
    "\30\0\1\u019a\43\0\1\u019b\30\0\1\u019b\26\0\1\u019c"+
    "\31\0\1\u019c\56\0\1\u019d\27\0\40\u018e\1\u019e\30\u018e"+
    "\2\47\2\0\3\47\1\70\23\47\1\u019f\4\47\2\0"+
    "\22\47\1\u019f\6\47\2\0\3\47\1\70\16\47\1\u01a0"+
    "\11\47\2\0\15\47\1\u01a0\11\47\40\u0191\1\u01a1\30\u0191"+
    "\1\0\2\u0192\1\0\1\u01a2\33\0\1\u01a3\1\0\1\u0192"+
    "\61\0\1\u01a4\30\0\1\u01a4\32\0\1\u01a5\30\0\1\u01a5"+
    "\16\0\1\u01a6\106\0\1\u01a7\30\0\1\u01a7\37\0\1\u01a8"+
    "\30\0\1\u01a8\42\0\1\u01a9\30\0\1\u01a9\35\0\1\u01aa"+
    "\30\0\1\u01aa\54\0\1\u01ab\62\0\1\u01ac\30\0\1\u01ac"+
    "\32\0\1\221\30\0\1\221\16\0\1\u01ad\63\0\2\47"+
    "\2\0\3\47\1\70\1\47\1\u01ae\26\47\2\0\1\47"+
    "\1\u01ae\27\47\2\0\3\47\1\u01af\30\47\2\0\27\47"+
    "\5\0\1\u01b0\111\0\1\u01b1\30\0\1\u01b1\35\0\1\u01b2"+
    "\30\0\1\u01b2\24\0\1\u01b3\31\0\1\u01b3\34\0\1\u01b4"+
    "\105\0\1\u01b5\30\0\1\u01b5\41\0\1\u01b6\30\0\1\u01b6"+
    "\37\0\1\u01b7\30\0\1\u01b7\52\0\1\u01b8\52\0\1\u01b9"+
    "\30\0\1\u01b9\15\0\2\u01ab\1\0\1\u01ba\33\0\1\u01bb"+
    "\1\0\1\u01ab\37\0\1\u01bc\31\0\1\u01bc\51\0\1\u01bd"+
    "\30\0\1\u01bd\13\0\2\47\2\0\3\47\1\70\23\47"+
    "\1\u01be\4\47\2\0\22\47\1\u01be\4\47\6\0\1\u01bf"+
    "\106\0\1\u01c0\30\0\1\u01c0\25\0\1\u01c1\31\0\1\u01c1"+
    "\47\0\1\u01c2\30\0\1\u01c2\47\0\1\u01c3\30\0\1\u01c3"+
    "\12\0\1\u01c4\105\0\1\u01c5\30\0\1\u01c5\55\0\1\u01c6"+
    "\70\0\1\u01c7\30\0\2\u01b8\1\0\1\u01c8\2\0\1\u01b8"+
    "\30\0\1\u01c9\1\0\1\u01b8\54\0\1\u01ca\30\0\1\u01ca"+
    "\37\0\1\u01cb\30\0\1\u01cb\35\0\1\u01cc\30\0\1\u01cc"+
    "\46\0\1\u01cd\30\0\1\u01cd\27\0\1\u01ce\30\0\1\u01ce"+
    "\14\0\2\47\2\0\3\47\1\70\17\47\1\u012e\10\47"+
    "\2\0\16\47\1\u012e\10\47\6\0\1\u01bf\32\0\1\u01cf"+
    "\52\0\1\u01d0\30\0\1\u01d0\46\0\1\u01d1\30\0\1\u01d1"+
    "\33\0\1\u01d2\30\0\1\u01d2\40\0\1\u0134\30\0\1\u0134"+
    "\16\0\1\u01c4\32\0\1\u01d3\55\0\1\u01d4\30\0\1\u01d4"+
    "\12\0\2\u01c6\1\0\1\u01d5\2\0\1\u01b8\30\0\1\u01d6"+
    "\1\0\1\u01c6\27\0\2\u01c7\1\0\1\u01d7\33\0\1\u01d8"+
    "\1\0\1\u01c7\54\0\1\u01d9\30\0\1\u01d9\35\0\1\u01da"+
    "\30\0\1\u01da\54\0\1\u01db\41\0\1\u01dc\31\0\1\u01dc"+
    "\47\0\1\u01dd\30\0\1\u01dd\43\0\1\221\30\0\1\221"+
    "\36\0\1\u01de\30\0\1\u01de\11\0\40\u01df\1\0\30\u01df"+
    "\26\0\1\u01e0\30\0\1\u01e0\41\0\1\u01e1\30\0\1\u01e1"+
    "\16\0\1\u01e2\122\0\1\u01e3\55\0\1\u01e4\30\0\1\u01e4"+
    "\35\0\1\u01e5\30\0\1\u01e5\41\0\1\u01e6\30\0\1\u01e6"+
    "\35\0\1\u01e7\30\0\1\u01e7\25\0\1\u01e8\31\0\1\u01e8"+
    "\47\0\1\u01e9\30\0\1\u01e9\15\0\2\u01db\1\0\1\u01ea"+
    "\33\0\1\u01eb\1\0\1\u01db\60\0\1\u01ec\30\0\1\u01ec"+
    "\33\0\1\u01ed\30\0\1\u01ed\52\0\1\u01ee\27\0\40\u01df"+
    "\1\u01ef\30\u01df\41\0\1\u01f0\37\0\1\u0192\74\0\1\u01f1"+
    "\7\0\1\u01f2\5\0\1\u01f3\13\0\1\u01f1\6\0\1\u01f2"+
    "\5\0\1\u01f3\6\0\2\u01e3\1\0\1\u01f4\33\0\1\u01f5"+
    "\1\0\1\u01e3\40\0\1\u01f6\31\0\1\u01f6\47\0\1\u01f7"+
    "\30\0\1\u01f7\26\0\1\u01f8\31\0\1\u01f8\47\0\1\u01f9"+
    "\30\0\1\u01f9\46\0\1\u01fa\30\0\1\u01fa\33\0\1\u01fb"+
    "\30\0\1\u01fb\37\0\1\u01fc\30\0\1\u01fc\35\0\1\u01fd"+
    "\30\0\1\u01fd\43\0\1\u01fe\30\0\1\u01fe\16\0\1\u01ff"+
    "\62\0\2\u01ee\1\0\1\u0200\33\0\1\u0201\1\0\1\u01ee"+
    "\33\0\1\u0202\64\0\2\u01f0\1\0\1\u0203\33\0\1\u0204"+
    "\1\0\1\u01f0\55\0\1\u0205\30\0\1\u0205\25\0\1\u0206"+
    "\31\0\1\u0206\54\0\1\u0207\30\0\1\u0207\32\0\1\u0208"+
    "\30\0\1\u0208\35\0\1\u0209\30\0\1\u0209\45\0\1\u020a"+
    "\30\0\1\u020a\33\0\1\u020b\30\0\1\u020b\43\0\1\u020c"+
    "\30\0\1\u020c\33\0\1\u020d\30\0\1\u020d\41\0\1\u020e"+
    "\30\0\1\u020e\16\0\1\u020f\73\0\1\u0210\31\0\1\u0210"+
    "\47\0\1\u0211\30\0\1\u0211\24\0\1\u01ab\74\0\1\u0212"+
    "\7\0\1\u0213\5\0\1\u0214\13\0\1\u0212\6\0\1\u0213"+
    "\5\0\1\u0214\33\0\1\u0215\30\0\1\u0215\35\0\1\u0216"+
    "\30\0\1\u0216\37\0\1\u0217\30\0\1\u0217\41\0\1\u0218"+
    "\30\0\1\u0218\35\0\1\u0219\30\0\1\u0219\26\0\1\u021a"+
    "\31\0\1\u021a\42\0\1\u021b\31\0\1\u021b\47\0\1\u021c"+
    "\30\0\1\u021c\21\0\1\u021d\31\0\1\u021d\47\0\1\u021e"+
    "\30\0\1\u021e\44\0\1\u021f\30\0\1\u021f\16\0\1\u0220"+
    "\111\0\1\u0221\30\0\1\u0221\16\0\1\u0222\71\0\1\u01b8"+
    "\74\0\1\u0223\11\0\1\u0224\3\0\1\u0225\13\0\1\u0223"+
    "\10\0\1\u0224\3\0\1\u0225\37\0\1\u0226\30\0\1\u0226"+
    "\33\0\1\u0227\30\0\1\u0227\40\0\1\u0228\30\0\1\u0228"+
    "\25\0\1\u0229\31\0\1\u0229\54\0\1\u022a\30\0\1\u022a"+
    "\16\0\1\u022b\31\0\1\u022b\47\0\1\u022c\30\0\1\u022c"+
    "\37\0\1\u022d\30\0\1\u022d\26\0\1\u022e\31\0\1\u022e"+
    "\47\0\1\u022f\30\0\1\u022f\47\0\1\u0230\30\0\1\u0230"+
    "\46\0\1\u0231\64\0\1\u0232\30\0\1\u0232\33\0\1\u0233"+
    "\30\0\1\u0233\33\0\1\u0234\30\0\1\u0234\21\0\1\u01c6"+
    "\71\0\1\u0235\2\0\1\u0223\7\0\1\u0236\1\0\1\u0224"+
    "\3\0\1\u0237\10\0\1\u0235\2\0\1\u0223\6\0\1\u0236"+
    "\1\0\1\u0224\3\0\1\u0237\15\0\1\u01c7\74\0\1\u0238"+
    "\2\0\1\u0239\6\0\1\u023a\3\0\1\u023b\4\0\1\u023c"+
    "\6\0\1\u0238\2\0\1\u0239\5\0\1\u023a\3\0\1\u023b"+
    "\4\0\1\u023c\27\0\1\u023d\30\0\1\u023d\44\0\1\u023e"+
    "\30\0\1\u023e\36\0\1\u023f\30\0\1\u023f\34\0\1\u0240"+
    "\30\0\1\u0240\16\0\1\u0241\74\0\1\u0242\31\0\1\u0242"+
    "\42\0\1\u0243\31\0\1\u0243\47\0\1\u0244\30\0\1\u0244"+
    "\41\0\1\u0245\30\0\1\u0245\33\0\1\u0246\30\0\1\u0246"+
    "\37\0\1\u0247\30\0\1\u0247\43\0\1\u0248\30\0\1\u0248"+
    "\33\0\1\u0249\30\0\1\u0249\50\0\1\u024a\30\0\1\u024a"+
    "\14\0\1\u01f1\31\0\1\u01f1\31\0\1\u024b\111\0\1\u024c"+
    "\30\0\1\u024c\16\0\1\u024d\115\0\1\u024e\30\0\1\u024e"+
    "\20\0\1\u024f\31\0\1\u024f\54\0\1\u0250\30\0\1\u0250"+
    "\33\0\1\u0251\30\0\1\u0251\44\0\1\u0252\30\0\1\u0252"+
    "\37\0\1\u0253\30\0\1\u0253\36\0\1\u0254\30\0\1\u0254"+
    "\21\0\1\u0255\31\0\1\u0255\34\0\1\u0256\31\0\1\u0256"+
    "\50\0\1\u0257\30\0\1\u0257\42\0\1\u0258\30\0\1\u0258"+
    "\17\0\1\u01db\71\0\1\u0259\12\0\1\u025a\5\0\1\u025b"+
    "\10\0\1\u0259\11\0\1\u025a\5\0\1\u025b\40\0\1\u025c"+
    "\30\0\1\u025c\46\0\1\u025d\64\0\1\215\30\0\1\215"+
    "\31\0\1\u025e\30\0\1\u025e\16\0\1\u025f\122\0\1\u0260"+
    "\57\0\1\u0261\30\0\1\u0261\16\0\1\u0262\111\0\1\u0263"+
    "\30\0\1\u0263\7\0\2\u024b\2\0\3\u024b\1\240\30\u024b"+
    "\2\0\27\u024b\10\0\1\u01e3\71\0\1\u0264\12\0\1\u0265"+
    "\5\0\1\u0266\10\0\1\u0264\11\0\1\u0265\5\0\1\u0266"+
    "\40\0\1\u0267\30\0\1\u0267\23\0\1\u0268\31\0\1\u0268"+
    "\47\0\1\u0269\30\0\1\u0269\22\0\1\u026a\31\0\1\u026a"+
    "\65\0\1\u026b\53\0\1\u026c\30\0\1\u026c\42\0\1\u026d"+
    "\30\0\1\u026d\20\0\1\u026e\31\0\1\u026e\67\0\1\u026f"+
    "\40\0\1\u0270\31\0\1\u0270\62\0\1\u0271\30\0\1\u0271"+
    "\35\0\1\u0272\30\0\1\u0272\20\0\1\u0273\31\0\1\u0273"+
    "\54\0\1\u0274\30\0\1\u0274\43\0\1\u0275\30\0\1\u0275"+
    "\14\0\1\u0212\31\0\1\u0212\32\0\1\u01ee\74\0\1\u0276"+
    "\7\0\1\u0277\5\0\1\u0278\13\0\1\u0276\6\0\1\u0277"+
    "\5\0\1\u0278\6\0\2\u0260\1\0\1\u0279\33\0\1\u027a"+
    "\1\0\1\u0260\36\0\1\u01f0\74\0\1\u027b\7\0\1\u027c"+
    "\5\0\1\u027d\13\0\1\u027b\6\0\1\u027c\5\0\1\u027d"+
    "\22\0\1\u027e\31\0\1\u027e\55\0\1\u027f\30\0\1\u027f"+
    "\20\0\1\u0280\31\0\1\u0280\54\0\1\u0281\30\0\1\u0281"+
    "\24\0\1\u0282\31\0\1\u0282\60\0\1\u0283\64\0\1\u0284"+
    "\30\0\1\u0284\43\0\1\u0285\37\0\1\u0286\31\0\1\u0286"+
    "\37\0\1\u0287\31\0\1\u0287\62\0\1\u0288\30\0\1\u0288"+
    "\32\0\1\u0289\30\0\1\u0289\22\0\1\u028a\31\0\1\u028a"+
    "\37\0\1\u028b\31\0\1\u028b\30\0\1\u028c\114\0\1\u028d"+
    "\30\0\1\u028d\23\0\1\u028e\31\0\1\u028e\47\0\1\u028f"+
    "\30\0\1\u028f\37\0\1\u0290\30\0\1\u0290\36\0\1\u0291"+
    "\30\0\1\u0291\25\0\1\u0292\31\0\1\u0292\54\0\1\u0293"+
    "\30\0\1\u0293\32\0\1\u0294\30\0\1\u0294\35\0\1\u0295"+
    "\30\0\1\u0295\42\0\1\u0296\30\0\1\u0296\25\0\1\u0297"+
    "\31\0\1\u0297\54\0\1\u0298\30\0\1\u0298\13\0\1\u0299"+
    "\114\0\1\u029a\30\0\1\u029a\23\0\1\u029b\31\0\1\u029b"+
    "\47\0\1\u029c\30\0\1\u029c\16\0\1\u029d\72\0\1\u0235"+
    "\31\0\1\u0235\34\0\1\u029e\75\0\1\u029f\31\0\1\u029f"+
    "\55\0\1\u02a0\30\0\1\u02a0\21\0\1\u02a1\31\0\1\u02a1"+
    "\30\0\1\u02a2\70\0\1\u02a3\72\0\1\u02a4\31\0\1\u02a4"+
    "\56\0\1\u02a5\30\0\1\u02a5\6\0\2\u028c\2\0\3\u028c"+
    "\1\335\30\u028c\2\0\27\u028c\20\0\1\u02a6\31\0\1\u02a6"+
    "\60\0\1\u02a7\64\0\1\u02a8\30\0\1\u02a8\16\0\1\u02a9"+
    "\31\0\1\u02a9\34\0\1\u02aa\31\0\1\u02aa\42\0\1\u02ab"+
    "\31\0\1\u02ab\47\0\1\u02ac\30\0\1\u02ac\21\0\1\u02ad"+
    "\31\0\1\u02ad\47\0\1\u02ae\30\0\1\u02ae\27\0\1\u02af"+
    "\31\0\1\u02af\42\0\1\u02b0\31\0\1\u02b0\47\0\1\u02b1"+
    "\30\0\1\u02b1\23\0\1\u02b2\31\0\1\u02b2\42\0\1\u02b3"+
    "\31\0\1\u02b3\60\0\1\u02b4\64\0\1\u02b5\30\0\1\u02b5"+
    "\14\0\1\u02b6\10\0\1\u02b7\4\0\1\u02b8\13\0\1\u02b6"+
    "\7\0\1\u02b7\4\0\1\u02b8\6\0\2\u029e\2\0\3\u029e"+
    "\1\375\30\u029e\2\0\27\u029e\11\0\1\u02b9\31\0\1\u02b9"+
    "\60\0\1\u026e\30\0\1\u026e\35\0\1\u02ba\30\0\1\u02ba"+
    "\6\0\2\u02a2\2\0\3\u02a2\1\377\30\u02a2\2\0\27\u02a2"+
    "\2\u02a3\2\0\3\u02a3\1\u02bb\30\u02a3\2\0\27\u02a3\33\0"+
    "\1\u02bc\30\0\1\u02bc\13\0\1\u02bd\32\0\1\u02be\35\0"+
    "\1\u02bf\72\0\1\u0259\31\0\1\u0259\34\0\1\u02c0\70\0"+
    "\1\u02c1\114\0\1\u02c2\30\0\1\u02c2\46\0\1\u02c3\64\0"+
    "\1\u02c4\30\0\1\u02c4\33\0\1\u02c5\30\0\1\u02c5\33\0"+
    "\1\u02c6\30\0\1\u02c6\44\0\1\u02c7\30\0\1\u02c7\46\0"+
    "\1\u02c8\64\0\1\u02c9\30\0\1\u02c9\16\0\1\u02ca\6\0"+
    "\1\u02cb\22\0\1\u02ca\5\0\1\u02cb\22\0\1\u02cc\72\0"+
    "\1\u0264\31\0\1\u0264\34\0\1\u02cd\72\0\1\u02ce\31\0"+
    "\1\u02ce\61\0\1\u02cf\30\0\1\u02cf\20\0\1\u02d0\31\0"+
    "\1\u02d0\54\0\1\u02d1\30\0\1\u02d1\13\0\1\u02a3\32\0"+
    "\1\u02d2\34\0\1\u02d3\77\0\1\u02d4\31\0\1\u02d4\21\0"+
    "\2\u02bd\2\0\3\u02bd\1\u02d5\30\u02bd\2\0\27\u02bd\37\0"+
    "\1\u02d6\30\0\1\u02d6\30\0\1\u02d7\30\0\1\u02d7\7\0"+
    "\2\u02c0\2\0\3\u02c0\1\u0124\30\u02c0\2\0\27\u02c0\17\0"+
    "\1\273\31\0\1\273\56\0\1\u02d8\30\0\1\u02d8\14\0"+
    "\1\u0276\31\0\1\u0276\31\0\1\u02d9\111\0\1\u02da\30\0"+
    "\1\u02da\16\0\1\u02db\120\0\1\u02dc\30\0\1\u02dc\14\0"+
    "\1\u027b\31\0\1\u027b\31\0\1\u02dd\74\0\1\u02de\31\0"+
    "\1\u02de\32\0\1\u02df\7\0\1\u02e0\31\0\1\u02e0\32\0"+
    "\1\u02b6\10\0\1\u02b7\3\0\1\u02e1\1\u02b8\13\0\1\u02b6"+
    "\7\0\1\u02b7\3\0\1\u02e1\1\u02b8\6\0\2\u02cd\2\0"+
    "\3\u02cd\1\u013e\30\u02cd\2\0\27\u02cd\30\0\1\u02e2\30\0"+
    "\1\u02e2\36\0\1\u02e3\30\0\1\u02e3\17\0\1\u02df\76\0"+
    "\1\u0289\31\0\1\u0289\60\0\1\u023c\30\0\1\u023c\6\0"+
    "\1\u02d3\32\0\1\u02e4\36\0\1\u02e5\67\0\1\u02e6\77\0"+
    "\1\u02e7\31\0\1\u02e7\52\0\1\u02e8\30\0\1\u02e8\36\0"+
    "\1\u02e9\30\0\1\u02e9\7\0\2\u02d9\2\0\3\u02d9\1\u014f"+
    "\30\u02d9\2\0\27\u02d9\10\0\1\u0260\74\0\1\u02ea\7\0"+
    "\1\u02eb\5\0\1\u02ec\13\0\1\u02ea\6\0\1\u02eb\5\0"+
    "\1\u02ec\35\0\1\u02ed\30\0\1\u02ed\7\0\2\u02dd\2\0"+
    "\3\u02dd\1\u0153\30\u02dd\2\0\27\u02dd\31\0\1\u02d0\30\0"+
    "\1\u02d0\14\0\1\u02ee\114\0\1\u02d0\30\0\1\u02d0\36\0"+
    "\1\u02ef\30\0\1\u02ef\35\0\1\u02f0\30\0\1\u02f0\27\0"+
    "\1\u02f1\31\0\1\u02f1\17\0\40\u02f2\1\0\30\u02f2\2\u02e5"+
    "\2\0\3\u02e5\1\u02f3\30\u02e5\2\0\27\u02e5\6\0\1\u02e6"+
    "\32\0\1\u02f4\40\0\1\u02f5\31\0\1\u02f5\42\0\1\u02f6"+
    "\31\0\1\u02f6\36\0\1\u02f7\31\0\1\u02f7\50\0\1\u02f8"+
    "\30\0\1\u02f8\25\0\1\u02f9\31\0\1\u02f9\54\0\1\u02fa"+
    "\30\0\1\u02fa\21\0\1\u02fb\31\0\1\u02fb\27\0\1\u02ee"+
    "\32\0\1\u02fc\44\0\1\u02fd\31\0\1\u02fd\63\0\1\u02fe"+
    "\55\0\1\u02ff\30\0\1\u02ff\10\0\40\u02f2\1\u0300\30\u02f2"+
    "\6\0\1\u0301\62\0\40\u0302\1\0\30\u0302\31\0\1\u0303"+
    "\30\0\1\u0303\40\0\1\u0304\30\0\1\u0304\14\0\1\u0305"+
    "\74\0\1\u0306\31\0\1\u0306\42\0\1\u0307\31\0\1\u0307"+
    "\47\0\1\u0308\30\0\1\u0308\16\0\1\u0309\61\0\40\u030a"+
    "\1\0\30\u030a\32\0\1\u030b\30\0\1\u030b\24\0\1\u030c"+
    "\10\0\1\u030d\20\0\1\u030c\7\0\1\u030d\42\0\1\u030e"+
    "\30\0\1\u030e\11\0\1\u030f\71\0\1\u0301\32\0\1\u0310"+
    "\27\0\40\u0302\1\u0311\30\u0302\7\0\1\u0312\123\0\1\u0313"+
    "\42\0\1\u0314\31\0\1\u0314\55\0\1\u0315\30\0\1\u0315"+
    "\46\0\1\u0316\64\0\1\u0317\30\0\1\u0317\15\0\1\u0318"+
    "\31\0\1\u0318\22\0\40\u030a\1\u0319\30\u030a\42\0\1\u031a"+
    "\55\0\1\u031b\30\0\1\u031b\41\0\1\u031c\30\0\1\u031c"+
    "\23\0\1\u031d\31\0\1\u031d\45\0\1\u031e\30\0\1\u031e"+
    "\13\0\40\u031f\1\0\30\u031f\5\0\1\u0320\63\0\2\u0312"+
    "\2\0\3\u0312\1\u0321\30\u0312\2\0\27\u0312\13\0\1\u0322"+
    "\31\0\1\u0322\40\0\1\u0323\6\0\1\u0324\22\0\1\u0323"+
    "\5\0\1\u0324\52\0\1\u0325\30\0\1\u0325\14\0\1\u02ea"+
    "\31\0\1\u02ea\31\0\1\u0326\76\0\1\u0323\31\0\1\u0323"+
    "\26\0\1\u0327\76\0\1\u0322\15\0\1\u0328\13\0\1\u0322"+
    "\14\0\1\u0328\43\0\1\336\30\0\1\336\31\0\1\u0329"+
    "\30\0\1\u0329\36\0\1\u032a\30\0\1\u032a\34\0\1\u032b"+
    "\30\0\1\u032b\14\0\40\u031f\1\u032c\30\u031f\24\0\1\u032d"+
    "\30\0\1\u032d\21\0\1\u032e\111\0\1\u032f\30\0\1\u032f"+
    "\23\0\1\u0330\31\0\1\u0330\32\0\1\335\7\0\1\u0331"+
    "\31\0\1\u0331\47\0\1\u0332\30\0\1\u0332\7\0\2\u0326"+
    "\2\0\3\u0326\1\u01b4\30\u0326\2\0\27\u0326\24\0\1\u0333"+
    "\30\0\1\u0333\30\0\1\u0334\31\0\1\u0334\56\0\1\u0335"+
    "\30\0\1\u0335\17\0\1\u0336\31\0\1\u0336\47\0\1\u0337"+
    "\30\0\1\u0337\16\0\1\u0338\106\0\1\u0339\30\0\1\u0339"+
    "\22\0\1\u032e\32\0\1\u033a\55\0\1\u033b\30\0\1\u033b"+
    "\42\0\1\336\30\0\1\336\40\0\1\336\30\0\1\336"+
    "\22\0\1\u033c\31\0\1\u033c\44\0\1\u033d\30\0\1\u033d"+
    "\44\0\1\336\30\0\1\336\44\0\1\u033e\30\0\1\u033e"+
    "\30\0\1\u033f\30\0\1\u033f\52\0\1\u0340\53\0\1\u0341"+
    "\30\0\1\u0341\41\0\1\u0342\30\0\1\u0342\11\0\40\u0343"+
    "\1\0\30\u0343\32\0\1\u0344\30\0\1\u0344\14\0\1\u0345"+
    "\107\0\1\u0346\30\0\1\u0346\53\0\1\u0347\61\0\1\u0348"+
    "\30\0\1\u0348\27\0\1\u0349\30\0\1\u0349\55\0\1\u034a"+
    "\27\0\40\u0343\1\u034b\30\u0343\42\0\1\u034c\42\0\1\u0318"+
    "\12\0\1\u034d\16\0\1\u0318\11\0\1\u034d\51\0\1\u034e"+
    "\61\0\1\u034f\30\0\1\u034f\22\0\1\336\31\0\1\336"+
    "\47\0\1\u0350\30\0\1\u0350\12\0\2\u0351\1\0\1\u0352"+
    "\33\0\1\u0353\1\0\1\u0351\33\0\1\u0354\110\0\1\u0355"+
    "\30\0\1\u0355\43\0\1\u0356\30\0\1\u0356\7\0\2\u034e"+
    "\1\0\1\u0357\2\0\1\u034e\30\0\1\u0358\1\0\1\u034e"+
    "\61\0\1\u0359\30\0\1\u0359\45\0\1\u035a\55\0\1\u035b"+
    "\30\0\1\u035b\35\0\1\u035c\30\0\1\u035c\37\0\1\u035d"+
    "\30\0\1\u035d\34\0\1\u035e\31\0\1\u035e\31\0\1\336"+
    "\31\0\1\336\50\0\1\u035f\30\0\1\u035f\35\0\1\u0360"+
    "\30\0\1\u0360\24\0\1\u0361\31\0\1\u0361\26\0\2\u0362"+
    "\1\0\1\u0363\33\0\1\u0364\1\0\1\u0362\40\0\1\u0365"+
    "\31\0\1\u0365\47\0\1\u0366\30\0\1\u0366\37\0\1\u0367"+
    "\30\0\1\u0367\42\0\1\336\30\0\1\336\23\0\1\u0368"+
    "\31\0\1\u0368\47\0\1\u0369\30\0\1\u0369\47\0\1\u036a"+
    "\30\0\1\u036a\32\0\1\u036b\30\0\1\u036b\35\0\1\u036c"+
    "\30\0\1\u036c\45\0\1\u036d\30\0\1\u036d\33\0\1\u036e"+
    "\30\0\1\u036e\37\0\1\u036f\30\0\1\u036f\43\0\1\u0370"+
    "\30\0\1\u0370\33\0\1\u0371\30\0\1\u0371\40\0\1\336"+
    "\30\0\1\336\22\0\1\u0372\31\0\1\u0372\47\0\1\u0373"+
    "\30\0\1\u0373\44\0\1\u0374\30\0\1\u0374\16\0\1\u0375"+
    "\122\0\1\u0376\57\0\1\u0377\30\0\1\u0377\16\0\1\u0378"+
    "\113\0\1\u0379\30\0\1\u0379\33\0\1\u037a\30\0\1\u037a"+
    "\21\0\1\u0351\74\0\1\u037b\11\0\1\u037c\3\0\1\u037d"+
    "\13\0\1\u037b\10\0\1\u037c\3\0\1\u037d\6\0\2\u037e"+
    "\1\0\1\u037f\33\0\1\u0380\1\0\1\u037e\36\0\1\u034e"+
    "\74\0\1\u0381\1\0\1\u0382\7\0\1\u0383\3\0\1\u0384"+
    "\4\0\1\u0385\6\0\1\u0381\1\0\1\u0382\6\0\1\u0383"+
    "\3\0\1\u0384\4\0\1\u0385\30\0\1\u0386\30\0\1\u0386"+
    "\16\0\1\u0387\110\0\1\u0388\30\0\1\u0388\44\0\1\u0389"+
    "\30\0\1\u0389\36\0\1\u038a\30\0\1\u038a\32\0\1\u038b"+
    "\30\0\1\u038b\35\0\1\u038c\30\0\1\u038c\42\0\1\u038d"+
    "\30\0\1\u038d\44\0\1\u038e\30\0\1\u038e\37\0\1\u038f"+
    "\30\0\1\u038f\36\0\1\u0390\30\0\1\u0390\21\0\1\u0391"+
    "\31\0\1\u0391\31\0\1\u0362\74\0\1\u0223\11\0\1\u0392"+
    "\3\0\1\u0393\13\0\1\u0223\10\0\1\u0392\3\0\1\u0393"+
    "\20\0\1\u0394\31\0\1\u0394\50\0\1\u0395\30\0\1\u0395"+
    "\42\0\1\u0396\30\0\1\u0396\21\0\1\u0397\31\0\1\u0397"+
    "\47\0\1\u0398\30\0\1\u0398\27\0\1\u0399\31\0\1\u0399"+
    "\47\0\1\u039a\30\0\1\u039a\40\0\1\u039b\30\0\1\u039b"+
    "\42\0\1\u039c\30\0\1\u039c\20\0\1\u039d\31\0\1\u039d"+
    "\61\0\1\u039e\30\0\1\u039e\36\0\1\u039f\30\0\1\u039f"+
    "\46\0\1\u03a0\40\0\1\u03a1\31\0\1\u03a1\62\0\1\u03a2"+
    "\30\0\1\u03a2\33\0\1\u03a3\30\0\1\u03a3\33\0\1\u03a4"+
    "\30\0\1\u03a4\53\0\1\u03a5\52\0\1\u03a6\30\0\1\u03a6"+
    "\25\0\1\u03a7\31\0\1\u03a7\62\0\1\u03a8\30\0\1\u03a8"+
    "\32\0\1\u03a9\30\0\1\u03a9\33\0\1\u03aa\30\0\1\u03aa"+
    "\42\0\1\u03ab\30\0\1\u03ab\23\0\1\u03ac\31\0\1\u03ac"+
    "\37\0\1\u03ad\31\0\1\u03ad\30\0\1\u03ae\111\0\1\u03af"+
    "\30\0\1\u03af\16\0\1\u03b0\75\0\1\u03b1\31\0\1\u03b1"+
    "\64\0\1\u03b2\43\0\1\u03b3\31\0\1\u03b3\30\0\1\u03b4"+
    "\70\0\1\u03b5\73\0\1\u03b6\31\0\1\u03b6\62\0\1\u03b7"+
    "\30\0\1\u03b7\12\0\1\u03b8\31\0\1\u03b8\56\0\1\u03b9"+
    "\30\0\1\u03b9\6\0\2\u03ae\2\0\3\u03ae\1\u03ba\30\u03ae"+
    "\2\0\27\u03ae\10\0\1\u037e\74\0\1\u03bb\11\0\1\u03bc"+
    "\3\0\1\u03bd\13\0\1\u03bb\10\0\1\u03bc\3\0\1\u03bd"+
    "\16\0\1\u03be\31\0\1\u03be\53\0\1\u03bf\30\0\1\u03bf"+
    "\42\0\1\u03c0\30\0\1\u03c0\6\0\2\u03b4\2\0\3\u03b4"+
    "\1\u02df\30\u03b4\2\0\27\u03b4\2\u03b5\2\0\3\u03b5\1\u03c1"+
    "\30\u03b5\2\0\27\u03b5\15\0\1\u03c2\31\0\1\u03c2\30\0"+
    "\1\u03c3\114\0\1\u03c4\30\0\1\u03c4\13\0\1\u02bd\67\0"+
    "\1\u03c5\111\0\1\u03c6\30\0\1\u03c6\44\0\1\u03c7\30\0"+
    "\1\u03c7\36\0\1\u03c8\30\0\1\u03c8\37\0\1\u03c9\30\0"+
    "\1\u03c9\40\0\1\u03ca\30\0\1\u03ca\12\0\1\u03cb\32\0"+
    "\1\u03cc\34\0\1\u03cd\113\0\1\u03ce\30\0\1\u03ce\6\0"+
    "\2\u03c3\2\0\3\u03c3\1\u03cf\30\u03c3\2\0\27\u03c3\15\0"+
    "\1\u03d0\31\0\1\u03d0\27\0\1\u03c5\32\0\1\u03d1\42\0"+
    "\1\u03d2\31\0\1\u03d2\50\0\1\u03d3\30\0\1\u03d3\42\0"+
    "\1\u03d4\30\0\1\u03d4\24\0\1\u03d5\31\0\1\u03d5\46\0"+
    "\1\u03d6\30\0\1\u03d6\12\0\2\u03cb\2\0\3\u03cb\1\u03d7"+
    "\30\u03cb\2\0\27\u03cb\37\0\1\u03d8\30\0\1\u03d8\6\0"+
    "\1\u03cd\32\0\1\u03d9\36\0\1\u03da\32\0\1\u03db\34\0"+
    "\1\u03dc\71\0\1\u03dd\61\0\40\u03de\1\0\30\u03de\42\0"+
    "\1\u03df\40\0\1\u03e0\31\0\1\u03e0\62\0\1\u03e1\30\0"+
    "\1\u03e1\10\0\1\u03e2\73\0\1\u03e3\31\0\1\u03e3\32\0"+
    "\1\u03e4\77\0\1\u03e5\31\0\1\u03e5\21\0\40\u03e6\1\0"+
    "\30\u03e6\2\u03da\2\0\3\u03da\1\u03e7\30\u03da\2\0\27\u03da"+
    "\37\0\1\u03e8\30\0\1\u03e8\6\0\1\u03dc\32\0\1\u03e9"+
    "\27\0\2\u03dd\2\0\3\u03dd\1\u03ea\30\u03dd\2\0\27\u03dd"+
    "\40\u03de\1\u03eb\30\u03de\14\0\1\u03ec\31\0\1\u03ec\37\0"+
    "\1\u03ed\31\0\1\u03ed\30\0\1\u03ee\61\0\2\u03e2\2\0"+
    "\3\u03e2\1\u03ef\30\u03e2\2\0\27\u03e2\15\0\1\u03f0\31\0"+
    "\1\u03f0\27\0\1\u03e4\32\0\1\u03f1\40\0\1\u03f0\31\0"+
    "\1\u03f0\25\0\40\u03e6\1\u03f2\30\u03e6\6\0\1\u03f3\77\0"+
    "\1\u03f4\31\0\1\u03f4\21\0\40\u03f5\1\0\30\u03f5\6\0"+
    "\1\u03f6\67\0\1\u03f7\74\0\1\u03f8\31\0\1\u03f8\56\0"+
    "\1\u03f9\30\0\1\u03f9\6\0\2\u03ee\2\0\3\u03ee\1\u03fa"+
    "\30\u03ee\2\0\27\u03ee\6\0\1\u03fb\113\0\1\u03fc\30\0"+
    "\1\u03fc\6\0\40\u03fd\1\0\30\u03fd\5\0\1\u03fe\71\0"+
    "\1\u03f3\32\0\1\u03ff\40\0\1\u0400\31\0\1\u0400\25\0"+
    "\40\u03f5\1\u0401\30\u03f5\6\0\1\u03f6\32\0\1\u0402\53\0"+
    "\1\u0403\30\0\1\u0403\46\0\1\u0404\30\0\1\u0404\46\0"+
    "\1\u02be\34\0\1\u0405\70\0\1\u03fb\32\0\1\u0406\36\0"+
    "\1\u03cb\61\0\40\u03fd\1\u0407\30\u03fd\24\0\1\u0408\30\0"+
    "\1\u0408\13\0\40\u0409\1\0\30\u0409\31\0\1\u040a\30\0"+
    "\1\u040a\13\0\1\u040b\63\0\40\u040c\1\0\30\u040c\23\0"+
    "\1\u040d\30\0\1\u040d\31\0\1\u040e\31\0\1\u040e\27\0"+
    "\1\u0405\32\0\1\u040f\27\0\40\u0410\1\0\30\u0410\5\0"+
    "\1\u0411\106\0\1\u0412\30\0\1\u0412\14\0\40\u0409\1\u0413"+
    "\30\u0409\7\0\1\u0414\105\0\1\u0415\30\0\1\u0415\13\0"+
    "\40\u040c\1\u0416\30\u040c\26\0\1\u0417\30\0\1\u0417\20\0"+
    "\1\u0418\61\0\40\u0419\1\0\30\u0419\40\u0410\1\u041a\30\u0410"+
    "\24\0\1\u041b\30\0\1\u041b\41\0\1\u041c\30\0\1\u041c"+
    "\16\0\1\u041d\63\0\2\u0414\2\0\3\u0414\1\u041e\30\u0414"+
    "\2\0\27\u0414\23\0\1\u041f\30\0\1\u041f\21\0\1\u0420"+
    "\124\0\1\u0351\27\0\2\u0418\2\0\3\u0418\1\u0421\30\u0418"+
    "\2\0\27\u0418\40\u0419\1\u0422\30\u0419\5\0\1\u0423\106\0"+
    "\1\u0424\30\0\1\u0424\55\0\1\u0425\53\0\1\u0426\30\0"+
    "\1\u0426\21\0\1\u0427\110\0\1\u0428\30\0\1\u0428\35\0"+
    "\1\u0429\30\0\1\u0429\21\0\1\u042a\67\0\1\u042b\107\0"+
    "\1\u042c\30\0\1\u042c\41\0\1\u042d\30\0\1\u042d\12\0"+
    "\2\u0425\1\0\1\u042e\33\0\1\u042f\1\0\1\u0425\51\0"+
    "\1\u0430\30\0\1\u0430\22\0\1\u0427\32\0\1\u0431\70\0"+
    "\1\u0362\52\0\1\u0432\30\0\1\u0432\22\0\1\u042a\32\0"+
    "\1\u0433\53\0\1\u0434\30\0\1\u0434\36\0\1\u0435\30\0"+
    "\1\u0435\55\0\1\u0436\55\0\1\u0437\30\0\1\u0437\35\0"+
    "\1\u0438\30\0\1\u0438\41\0\1\u0439\30\0\1\u0439\11\0"+
    "\40\u043a\1\0\30\u043a\26\0\1\u043b\30\0\1\u043b\11\0"+
    "\40\u043c\1\0\30\u043c\23\0\1\u043d\30\0\1\u043d\42\0"+
    "\1\u043e\30\0\1\u043e\12\0\2\u043f\1\0\1\u0440\33\0"+
    "\1\u0441\1\0\1\u043f\40\0\1\u0442\31\0\1\u0442\47\0"+
    "\1\u0443\30\0\1\u0443\55\0\1\u0444\27\0\40\u043a\1\u0445"+
    "\30\u043a\41\0\1\u0446\27\0\40\u043c\1\u0447\30\u043c\26\0"+
    "\1\u0448\30\0\1\u0448\52\0\1\u0449\55\0\1\u044a\30\0"+
    "\1\u044a\35\0\1\u044b\30\0\1\u044b\45\0\1\u044c\30\0"+
    "\1\u044c\33\0\1\u044d\30\0\1\u044d\12\0\2\u044e\1\0"+
    "\1\u044f\33\0\1\u0450\1\0\1\u044e\33\0\1\u0451\64\0"+
    "\2\u0452\1\0\1\u0453\33\0\1\u0454\1\0\1\u0452\33\0"+
    "\1\u0455\124\0\1\u037e\30\0\2\u0456\1\0\1\u0457\33\0"+
    "\1\u0458\1\0\1\u0456\40\0\1\u0459\31\0\1\u0459\47\0"+
    "\1\u045a\30\0\1\u045a\44\0\1\u045b\30\0\1\u045b\16\0"+
    "\1\u045c\107\0\1\u045d\30\0\1\u045d\35\0\1\u045e\30\0"+
    "\1\u045e\37\0\1\u045f\30\0\1\u045f\41\0\1\u0460\30\0"+
    "\1\u0460\35\0\1\u0461\30\0\1\u0461\37\0\1\u0462\30\0"+
    "\1\u0462\41\0\1\u0463\30\0\1\u0463\35\0\1\u0464\30\0"+
    "\1\u0464\45\0\1\u0465\30\0\1\u0465\33\0\1\u0466\30\0"+
    "\1\u0466\21\0\1\u0425\106\0\1\u0467\3\0\1\u0468\24\0"+
    "\1\u0467\3\0\1\u0468\17\0\1\u0469\31\0\1\u0469\47\0"+
    "\1\u046a\30\0\1\u046a\37\0\1\u046b\30\0\1\u046b\26\0"+
    "\1\u046c\31\0\1\u046c\47\0\1\u046d\30\0\1\u046d\37\0"+
    "\1\u046e\30\0\1\u046e\26\0\1\u046f\31\0\1\u046f\47\0"+
    "\1\u0470\30\0\1\u0470\44\0\1\u0471\30\0\1\u0471\16\0"+
    "\1\u0472\115\0\1\u0473\30\0\1\u0473\36\0\1\u0474\30\0"+
    "\1\u0474\36\0\1\u0475\30\0\1\u0475\33\0\1\u0476\30\0"+
    "\1\u0476\37\0\1\u0477\30\0\1\u0477\43\0\1\u0478\30\0"+
    "\1\u0478\33\0\1\u0479\30\0\1\u0479\37\0\1\u047a\30\0"+
    "\1\u047a\43\0\1\u047b\30\0\1\u047b\33\0\1\u047c\30\0"+
    "\1\u047c\21\0\1\u043f\74\0\1\u047d\15\0\1\u047e\13\0"+
    "\1\u047d\14\0\1\u047e\32\0\1\u047f\30\0\1\u047f\42\0"+
    "\1\u0480\30\0\1\u0480\37\0\1\u0481\30\0\1\u0481\16\0"+
    "\1\u0482\122\0\1\u0483\57\0\1\u0484\30\0\1\u0484\16\0"+
    "\1\u0485\122\0\1\u0486\57\0\1\u0487\30\0\1\u0487\16\0"+
    "\1\u0488\110\0\1\u0489\30\0\1\u0489\43\0\1\u048a\30\0"+
    "\1\u048a\16\0\1\u048b\31\0\1\u048b\62\0\1\u03a9\30\0"+
    "\1\u03a9\11\0\1\u044e\74\0\1\u048c\15\0\1\u048d\13\0"+
    "\1\u048c\14\0\1\u048d\6\0\2\u048e\1\0\1\u048f\33\0"+
    "\1\u0490\1\0\1\u048e\36\0\1\u0452\106\0\1\u037c\3\0"+
    "\1\u0491\24\0\1\u037c\3\0\1\u0491\6\0\2\u0492\1\0"+
    "\1\u0493\33\0\1\u0494\1\0\1\u0492\36\0\1\u0456\76\0"+
    "\1\u0495\7\0\1\u0496\3\0\1\u0497\15\0\1\u0495\6\0"+
    "\1\u0496\3\0\1\u0497\20\0\1\u0498\31\0\1\u0498\53\0"+
    "\1\u0499\30\0\1\u0499\24\0\1\u049a\31\0\1\u049a\50\0"+
    "\1\u049b\30\0\1\u049b\43\0\1\u049c\30\0\1\u049c\32\0"+
    "\1\u049d\30\0\1\u049d\35\0\1\u049e\30\0\1\u049e\46\0"+
    "\1\u049f\30\0\1\u049f\32\0\1\u04a0\30\0\1\u04a0\35\0"+
    "\1\u04a1\30\0\1\u04a1\47\0\1\u04a2\30\0\1\u04a2\37\0"+
    "\1\u04a3\30\0\1\u04a3\36\0\1\u04a4\30\0\1\u04a4\46\0"+
    "\1\u04a5\64\0\1\u04a6\30\0\1\u04a6\32\0\1\u04a7\30\0"+
    "\1\u04a7\21\0\1\u04a8\31\0\1\u04a8\53\0\1\u04a9\30\0"+
    "\1\u04a9\21\0\1\u04aa\31\0\1\u04aa\47\0\1\u04ab\30\0"+
    "\1\u04ab\44\0\1\u04ac\30\0\1\u04ac\21\0\1\u04ad\31\0"+
    "\1\u04ad\47\0\1\u04ae\30\0\1\u04ae\40\0\1\u04af\30\0"+
    "\1\u04af\40\0\1\u04b0\30\0\1\u04b0\42\0\1\u04b1\30\0"+
    "\1\u04b1\23\0\1\u04b2\31\0\1\u04b2\31\0\1\u04b3\70\0"+
    "\1\u04b4\123\0\1\u04b5\64\0\1\u04b6\30\0\1\u04b6\33\0"+
    "\1\u04b7\30\0\1\u04b7\33\0\1\u04b8\30\0\1\u04b8\47\0"+
    "\1\u04b9\30\0\1\u04b9\33\0\1\u04ba\30\0\1\u04ba\33\0"+
    "\1\u04bb\30\0\1\u04bb\35\0\1\u04bc\30\0\1\u04bc\25\0"+
    "\1\u04bd\31\0\1\u04bd\62\0\1\u04be\30\0\1\u04be\12\0"+
    "\1\u04bf\31\0\1\u04bf\25\0\2\u04b3\2\0\3\u04b3\1\u04c0"+
    "\30\u04b3\2\0\27\u04b3\2\u04b4\2\0\3\u04b4\1\u04c1\30\u04b4"+
    "\2\0\27\u04b4\14\0\1\u04c2\31\0\1\u04c2\31\0\1\u04c3"+
    "\111\0\1\u04c4\30\0\1\u04c4\16\0\1\u04c5\70\0\1\u04c6"+
    "\111\0\1\u04c7\30\0\1\u04c7\16\0\1\u04c8\123\0\1\u04c9"+
    "\43\0\1\u04ca\31\0\1\u04ca\30\0\1\u04cb\114\0\1\u04cc"+
    "\30\0\1\u04cc\12\0\1\u04cd\70\0\1\u04ce\73\0\1\u04cf"+
    "\31\0\1\u04cf\25\0\2\u04c3\2\0\3\u04c3\1\u04d0\30\u04c3"+
    "\2\0\27\u04c3\10\0\1\u048e\74\0\1\u04d1\15\0\1\u04d2"+
    "\13\0\1\u04d1\14\0\1\u04d2\5\0\2\u04c6\2\0\3\u04c6"+
    "\1\u04d3\30\u04c6\2\0\27\u04c6\10\0\1\u0492\106\0\1\u03bc"+
    "\3\0\1\u04d4\24\0\1\u03bc\3\0\1\u04d4\33\0\1\u0467"+
    "\30\0\1\u0467\42\0\1\u04d5\30\0\1\u04d5\6\0\2\u04cb"+
    "\2\0\3\u04cb\1\u04d6\30\u04cb\2\0\27\u04cb\15\0\1\u04a7"+
    "\31\0\1\u04a7\27\0\1\u04cd\32\0\1\u04d7\35\0\1\u04ce"+
    "\32\0\1\u04d8\62\0\1\u04d9\30\0\1\u04d9\12\0\1\u04da"+
    "\111\0\1\u04db\30\0\1\u04db\43\0\1\u04dc\30\0\1\u04dc"+
    "\12\0\1\u04dd\115\0\1\u04de\30\0\1\u04de\13\0\1\u04b4"+
    "\32\0\1\u04df\34\0\1\u04e0\62\0\40\u04e1\1\0\30\u04e1"+
    "\40\u04e2\1\0\30\u04e2\15\0\1\u04e3\31\0\1\u04e3\27\0"+
    "\1\u04da\32\0\1\u04e4\42\0\1\u04e5\31\0\1\u04e5\53\0"+
    "\1\u04e6\30\0\1\u04e6\15\0\1\u04dd\32\0\1\u04e7\57\0"+
    "\1\u04e8\30\0\1\u04e8\46\0\1\u04e9\30\0\1\u04e9\6\0"+
    "\1\u04e0\32\0\1\u04ea\27\0\40\u04e1\1\u04eb\30\u04e1\40\u04e2"+
    "\1\u04ec\30\u04e2\7\0\1\u04ed\61\0\40\u04ee\1\0\30\u04ee"+
    "\42\0\1\u04ef\64\0\1\u04f0\30\0\1\u04f0\1\0\40\u04f1"+
    "\1\0\30\u04f1\36\0\1\u04f2\30\0\1\u04f2\16\0\1\u04f3"+
    "\31\0\1\u04f3\21\0\40\u04f4\1\0\30\u04f4\5\0\1\u04f5"+
    "\70\0\1\u04f6\63\0\2\u04ed\2\0\3\u04ed\1\u04f7\30\u04ed"+
    "\2\0\27\u04ed\40\u04ee\1\u04f8\30\u04ee\14\0\1\u04f9\31\0"+
    "\1\u04f9\31\0\1\u04fa\61\0\40\u04f1\1\u04fb\30\u04f1\7\0"+
    "\1\u04fc\72\0\1\u049a\31\0\1\u049a\25\0\40\u04f4\1\u04fd"+
    "\30\u04f4\24\0\1\u04fe\30\0\1\u04fe\37\0\1\u04ff\30\0"+
    "\1\u04ff\21\0\1\u0500\67\0\1\u0501\74\0\1\u0502\31\0"+
    "\1\u0502\25\0\2\u04fa\2\0\3\u04fa\1\u0503\30\u04fa\2\0"+
    "\27\u04fa\5\0\1\u0504\63\0\2\u04fc\2\0\3\u04fc\1\u0505"+
    "\30\u04fc\2\0\27\u04fc\5\0\1\u0506\106\0\1\u0507\30\0"+
    "\1\u0507\37\0\1\u0508\30\0\1\u0508\22\0\1\u0500\32\0"+
    "\1\u0509\53\0\1\u050a\30\0\1\u050a\46\0\1\u050b\30\0"+
    "\1\u050b\12\0\1\u050c\106\0\1\u050d\30\0\1\u050d\21\0"+
    "\1\u050e\106\0\1\u050f\30\0\1\u050f\41\0\1\u0510\30\0"+
    "\1\u0510\37\0\1\u0511\30\0\1\u0511\11\0\40\u0512\1\0"+
    "\30\u0512\23\0\1\u0513\30\0\1\u0513\31\0\1\u0514\31\0"+
    "\1\u0514\27\0\1\u050c\32\0\1\u0515\52\0\1\u0516\30\0"+
    "\1\u0516\22\0\1\u050e\32\0\1\u0517\52\0\1\u0518\30\0"+
    "\1\u0518\55\0\1\u043f\70\0\1\u0519\27\0\40\u0512\1\u051a"+
    "\30\u0512\26\0\1\u051b\30\0\1\u051b\20\0\1\u051c\61\0"+
    "\40\u051d\1\0\30\u051d\26\0\1\u051e\30\0\1\u051e\11\0"+
    "\40\u051f\1\0\30\u051f\26\0\1\u0520\30\0\1\u0520\16\0"+
    "\1\u0521\124\0\1\u044e\27\0\2\u051c\2\0\3\u051c\1\u0522"+
    "\30\u051c\2\0\27\u051c\40\u051d\1\u0523\30\u051d\41\0\1\u0452"+
    "\27\0\40\u051f\1\u0524\30\u051f\41\0\1\u0456\53\0\1\u0525"+
    "\30\0\1\u0525\21\0\1\u0526\67\0\1\u0527\70\0\1\u0528"+
    "\106\0\1\u0529\30\0\1\u0529\22\0\1\u0526\32\0\1\u052a"+
    "\53\0\1\u052b\30\0\1\u052b\37\0\1\u052c\30\0\1\u052c"+
    "\41\0\1\u052d\30\0\1\u052d\11\0\40\u052e\1\0\30\u052e"+
    "\23\0\1\u052f\30\0\1\u052f\37\0\1\u0530\30\0\1\u0530"+
    "\55\0\1\u0531\27\0\40\u052e\1\u0532\30\u052e\26\0\1\u0533"+
    "\30\0\1\u0533\37\0\1\u0534\30\0\1\u0534\12\0\2\u0535"+
    "\1\0\1\u0536\33\0\1\u0537\1\0\1\u0535\33\0\1\u0538"+
    "\124\0\1\u048e\70\0\1\u0492\55\0\1\u0539\30\0\1\u0539"+
    "\35\0\1\u053a\30\0\1\u053a\37\0\1\u053b\30\0\1\u053b"+
    "\25\0\1\u053c\31\0\1\u053c\47\0\1\u053d\30\0\1\u053d"+
    "\37\0\1\u053e\30\0\1\u053e\46\0\1\u053f\30\0\1\u053f"+
    "\33\0\1\u0540\30\0\1\u0540\37\0\1\u0541\30\0\1\u0541"+
    "\41\0\1\u0542\30\0\1\u0542\16\0\1\u0543\122\0\1\u0544"+
    "\37\0\1\u0535\74\0\1\u048c\11\0\1\u0545\3\0\1\u0546"+
    "\13\0\1\u048c\10\0\1\u0545\3\0\1\u0546\6\0\2\u0547"+
    "\1\0\1\u0548\33\0\1\u0549\1\0\1\u0547\62\0\1\u054a"+
    "\30\0\1\u054a\36\0\1\u054b\30\0\1\u054b\32\0\1\u054c"+
    "\30\0\1\u054c\35\0\1\u054d\30\0\1\u054d\40\0\1\u054e"+
    "\30\0\1\u054e\42\0\1\u054f\30\0\1\u054f\21\0\1\u0550"+
    "\31\0\1\u0550\47\0\1\u0551\30\0\1\u0551\26\0\1\u0552"+
    "\31\0\1\u0552\62\0\1\u0553\30\0\1\u0553\33\0\1\u0554"+
    "\30\0\1\u0554\33\0\1\u0555\30\0\1\u0555\26\0\1\u0556"+
    "\31\0\1\u0556\30\0\1\u0557\111\0\1\u0558\30\0\1\u0558"+
    "\16\0\1\u0559\112\0\1\u055a\30\0\1\u055a\6\0\2\u0557"+
    "\2\0\3\u0557\1\u055b\30\u0557\2\0\27\u0557\10\0\1\u0547"+
    "\74\0\1\u04d1\11\0\1\u055c\3\0\1\u055d\13\0\1\u04d1"+
    "\10\0\1\u055c\3\0\1\u055d\14\0\1\u03da\67\0\1\u055e"+
    "\116\0\1\u055f\30\0\1\u055f\36\0\1\u0560\30\0\1\u0560"+
    "\12\0\1\u055e\32\0\1\u0561\54\0\1\u0562\30\0\1\u0562"+
    "\42\0\1\u0563\30\0\1\u0563\7\0\40\u0564\1\0\30\u0564"+
    "\12\0\1\u0565\31\0\1\u0565\62\0\1\u0566\30\0\1\u0566"+
    "\1\0\40\u0564\1\u0567\30\u0564\15\0\1\u0568\31\0\1\u0568"+
    "\30\0\1\u0569\66\0\1\u056a\114\0\1\u056b\30\0\1\u056b"+
    "\6\0\2\u0569\2\0\3\u0569\1\u056c\30\u0569\2\0\27\u0569"+
    "\24\0\1\u056d\30\0\1\u056d\55\0\1\u03db\34\0\1\u056e"+
    "\105\0\1\u056f\30\0\1\u056f\22\0\1\u056e\32\0\1\u0570"+
    "\55\0\1\u0571\30\0\1\u0571\11\0\40\u0572\1\0\30\u0572"+
    "\41\0\1\u0535\27\0\40\u0572\1\u0573\30\u0572\5\0\1\u0574"+
    "\107\0\1\u0575\30\0\1\u0575\36\0\1\u0576\30\0\1\u0576"+
    "\42\0\1\u0577\30\0\1\u0577\52\0\1\u0547\27\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[78033];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\1\1\1\11\1\1\12\0"+
    "\1\11\106\0\1\11\163\0\1\1\62\0\1\1\32\0"+
    "\1\1\34\0\2\1\34\0\1\1\24\0\1\1\12\0"+
    "\2\11\1\1\3\0\1\1\36\0\1\11\61\0\1\1"+
    "\u0170\0\1\1\11\0\1\1\17\0\1\1\33\0\1\1"+
    "\277\0\1\1\15\0\1\1\1\0\1\1\2\0\1\1"+
    "\71\0\1\1\2\0\1\1\222\0\1\11\27\0\1\1"+
    "\22\0\1\1\63\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[1399];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S166_ReferencesPrimaryLegislation() { }
	
	private String context = "";

	//Text of a single citation
	private StringBuilder text = new StringBuilder();
	
	//Textual buffer between single citations
	private StringBuilder buffer = new StringBuilder();
	
	private ArrayList<AnnotationEntity> references = new ArrayList<AnnotationEntity>(); //collection dei Reference presenti nello stesso Pattern

	private void startReference() {
	
		text = new StringBuilder();
		buffer = new StringBuilder();
		references = new ArrayList<AnnotationEntity>();
		
		annotationEntity = new Reference(Entity.LEG_REF);
		references.add(annotationEntity);
		
		context = Util.removeAllAnnotations(yytext());
		((Reference) annotationEntity).setContext(context);
		
		annotationEntity.setPosition(position);

		length = yylength();		
	
		yypushback(length);
		offset = 0;
	
		yybegin(referenceState);	 
	}
	
	private void checkReference() {
	
		if( ((Reference) annotationEntity).isReference() ) {
		
			((Reference) annotationEntity).setText(Util.removeAllAnnotations(text.toString()));
			((Reference) annotationEntity).setContext(context.toString());
			
			//Add shared features
			for(Entity key : ((Reference) annotationEntity).name2sharedEntity.keySet()) {
				
				if(annotationEntity.getRelatedEntity(key) == null) {
					
					annotationEntity.addRelatedEntity(((Reference) annotationEntity).name2sharedEntity.get(key));
				}
			}
			
			//Add inverse related properties
			for(AnnotationEntity relatedEntity : annotationEntity.getRelatedEntities()) {
			
				relatedEntity.addRelatedEntity(annotationEntity);
			}
			
			addEntity(annotationEntity);
			
		} else {
			
			addText(text.toString());
		}

		addText(buffer.toString());
		
		text = new StringBuilder();
		text.append(yytext());
		buffer = new StringBuilder();
	
		Reference newAnnotationEntity = new Reference(Entity.LEG_REF);
		
		references.add(newAnnotationEntity);
		
		newAnnotationEntity.setPosition(position);
		newAnnotationEntity.setContext(context);
		
		newAnnotationEntity.name2sharedEntity.putAll(((Reference) annotationEntity).name2sharedEntity);		
		
		annotationEntity = newAnnotationEntity;
	}

	private void readFeature(boolean isShared) {
	
		AnnotationEntity retrievedEntity = retrieveEntity();
		
		offset += yylength();

		if(isShared) {
		
			((Reference) annotationEntity).name2sharedEntity.put(retrievedEntity.getEntity(), retrievedEntity);
		}
		
		if(annotationEntity.getRelatedEntity(retrievedEntity.getEntity()) != null) {

			checkReference();

		} else {
		
			text.append(buffer.toString());
			text.append(yytext());
			buffer = new StringBuilder();
		}

		annotationEntity.addRelatedEntity(retrievedEntity);
		
		position += retrievedEntity.getText().length();
	}



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S166_ReferencesPrimaryLegislation(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 11: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 12: break;
          case 3:
            { offset++;
		position++;
		
		if(offset >= length) {
			
			if(offset > length) {
				yypushback(1);
				position--;
			}
			
			checkReference();
			
			yybegin(0);

		} else {

			buffer.append(yytext());
		}
            }
          // fall through
          case 13: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 14: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 15: break;
          case 6:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		offset += yylength();
		position += retrievedEntity.getText().length();
		buffer.append(yytext());
            }
          // fall through
          case 16: break;
          case 7:
            { readFeature(false);
            }
          // fall through
          case 17: break;
          case 8:
            { readFeature(true);
            }
          // fall through
          case 18: break;
          case 9:
            { startReference();
            }
          // fall through
          case 19: break;
          case 10:
            { //System.out.println("PATTERN: " + yytext());

	startReference();
            }
          // fall through
          case 20: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S166_ReferencesPrimaryLegislation [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S166_ReferencesPrimaryLegislation scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S166_ReferencesPrimaryLegislation(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
